                                                                                
                                                                                
                                                                                
                                                                                
                                                                                
C                               PROGRAM TRACER II                        9CA0030
C                                                                        9CA0040
C     DESCRIPTION.   LATTICE TRANSFORMATION - CELL REDUCTION PROGRAM     9CA0050
C     AUTHOR         S. L. LAWTON, MOBIL RESEARCH AND DEVELOPMENT CORP., 9CA0060
C                    RESEARCH DEPT., PAULSBORO, NEW JERSEY 08066.        9CA0061
C     LANGUAGE.      FORTRAN IV FOR IBM 7040    (APRIL 1967)             9CA0070
C                    FORTRAN IV FOR IBM 360/44  (OCTOBER 1970)           9CA0071
C                                                                        9CA0080
C     INPUT DATA                                                         9CA0090
C                                                                        9CA0100
C  1. TITLE CARD -- FORMAT(35A2) -- ONE CARD.                            9CA0110
C                                                                        9CA0120
C          ANY ALPHANUMERIC INFORMATION DESCRIBING THE COMPOUND.  THIS   9CA0130
C          WILL BE PRINTED BACK OUT AS A HEADING ON EACH PAGE OF OUTPUT. 9CA0140
C                                                                        9CA0150
C  2. CONTROL CARD -- FORMAT(I3,F7.3) -- ONE CARD.                       9CA0160
C                                                                        9CA0170
C       COL. 1-3   INPUT =1 CELL PARAMETERS ON PARAMETER CARD ARE IN     9CA0180
C                           DIRECT SPACE                                 9CA0190
C                        =2 CELL PARAMETERS ON PARAMETER CARD ARE IN     9CA0200
C                           RECIPROCAL SPACE                             9CA0210
C       COL. 4-10   DEL     ABSOLUTE VALUE OF THE LARGEST PERMISSIBLE    9CA0220
C                           DIFFERENCE BETWEEN ANY TWO OF THE SIX RE-    9CA0230
C                           DUCED CELL SCALAR PRODUCTS.  (FOR LATTICE    9CA0240
C                           PARAMETERS WITH E.S.D. OF 1 PART IN 10000 A. 9CA0250
C                           DEL = 0.10 IS SATISFACTORY.  IF ABOUT 1 PART 9CA0260
C                           IN 1000 A., DEL = 0.50 TO 1.00 MAY BE        9CA0270
C                           NECESSARY.)                                  9CA0280
C                           THIS FIELD IS IRRELAVENT IF NO CELL          9CA0290
C                           REDUCTION IS TO BE MADE.                     9CA0300
C                                                                        9CA0310
C  3. PARAMETER CARD -- FORMAT(6F10.6) -- ONE CARD                       9CA0320
C                                                                        9CA0330
C       COL. 1-10    A      LATTICE PARAMETER A (OR A*)                  9CA0340
C       COL.11-20    B      LATTICE PARAMETER B (OR B*)                  9CA0350
C       COL.21-30    C      LATTICE PARAMETER C (OR C*)                  9CA0360
C       COL.31-40  ALPHA    LATTICE PARAMETER ALPHA (OR ALPHA*)          9CA0370
C       COL.41-50  BETA     LATTICE PARAMETER BETA  (OR BETA*)           9CA0380
C       COL.51-60  GAMMA    LATTICE PARAMETER GAMMA (OR GAMMA*)          9CA0390
C          (NOTE.  THE CELL EDGES ARE IN UNITS OF ANGSTROMS (IF INPUT=1) 9CA0400
C          AND INVERSE ANGSTROMS (IF INPUT=2).  ALL ANGLES ARE IN        9CA0410
C          DEGREES AND DECIMAL FRACTION.)                                9CA0420
C                                                                        9CA0430
C  4. INSTRUCTION CARDS -- FORMAT(I3,2X,25A3).                           9CA0440
C                                                                        9CA0450
C          THESE CARDS FUNCTION AS THE COMMANDS TO THE PROGRAM IN TRANS- 9CA0460
C          FORMING ONE CELL TO ANOTHER.  EACH CARD CONTAINS TWO ITEMS--  9CA0470
C          AN INSTRUCTION NUMBER (NQ) AND THE BRAVAIS LATTICE            9CA0480
C          DESCRIPTION OF THE CELL ON WHICH THE PROGRAM WILL OPERATE.    9CA0490
C          AS MANY CARDS AS ARE NECESSARY MAY BE USED TO COMPLETE THE    9CA0500
C          DESIRED SUCCESSIVE TRANSFORMATIONS FOR ANY ONE COMPOUND.      9CA0510
C          THEIR ORDER SPECIFIES TO THE PROGRAM THE ORDER IN WHICH THE   9CA0520
C          TRANSFORMATIONS ARE TO BE EXECUTED.    THE LAST INSTRUCTION   9CA0530
C          CARD FOR A PARTICULAR SEQUENCE OF TRANSFORMATIONS MUST HAVE   9CA0540
C          NQ = 7 OR 8.  BOTH MAY NOT BE PRESENT AND NEITHER MAY PRECEDE 9CA0550
C          ANY WITH NQ = 1,2,3,4,5 OR 6.  NQ = 7 TRIGGERS CELL REDUCTION 9CA0560
C          AND NQ = 8 MERELY IDENTIFIES THE LAST CELL IN A SEQUENCE TO   9CA0570
C          WHICH A TRANSFORMATION IS TO BE MADE WHEN NO CELL REDUCTION   9CA0580
C          IS PERFORMED.  THUS, INSTRUCTION CARDS ARE READ UNTIL THE     9CA0590
C          PROGRAM FINDS ONE WITH NQ = 7 OR 8.  INSTRUCTION CARDS WITH   9CA0600
C          NQ.LE.6 MAY BE INTERMIXED.                                    9CA0610
C                                                                        9CA0620
C                INSTR. CODE                INSTRUCTION                  9CA0630
C                                                                        9CA0640
C       COL. 3      NQ = 1  TRANSFORM THIS CELL TO A NEW CELL USING A    9CA0650
C                           MATRIX SUPPLIED BY THE USER ON THE CORRE-    9CA0660
C                           SPONDING TRANSFORMATION CARD.                9CA0670
C                      = 2  THIS CELL IS A-CENTERED.  THE PROGRAM WILL   9CA0680
C                           TRANSFORM IT TO A PRIMITIVE CELL USING A     9CA0690
C                           MATRIX IN SUBROUTINE CENTER.                 9CA0700
C                      = 3  THIS CELL IS B-CENTERED.  THE PROGRAM WILL   9CA0710
C                           TRANSFORM IT TO A PRIMITIVE CELL USING A     9CA0720
C                           MATRIX IN SUBROUTINE CENTER.                 9CA0730
C                      = 4  THIS CELL IS C-CENTERED.  THE PROGRAM WILL   9CA0740
C                           TRANSFORM IT TO A PRIMITIVE CELL USING A     9CA0750
C                           MATRIX IN SUBROUTINE CENTER.                 9CA0760
C                      = 5  THIS CELL IS BODY-CENTERED. THE PROGRAM WILL 9CA0770
C                           TRANSFORM IT TO A PRIMITIVE CELL USING A     9CA0780
C                           MATRIX IN SUBROUTINE CENTER.                 9CA0790
C                      = 6  THIS CELL IS FACE-CENTERED. THE PROGRAM WILL 9CA0800
C                           TRANSFORM IT TO A PRIMITIVE CELL USING A     9CA0810
C                           MATRIX IN SUBROUTINE CENTER.                 9CA0820
C                      = 7  TRANSFORM THIS CELL TO ITS REDUCED CELL AND  9CA0830
C                           THEN IDENTIFY AND GENERATE FROM IT THE UNIT  9CA0840
C                           CELL OF HIGHEST SYMMETRY AND ITS CORRESPOND- 9CA0850
C                           ING LATTICE PARAMETERS.  (ALL TRANSFORMATION 9CA0860
C                           MATRICES FOR THIS INSTRUCTION ARE GENERATED  9CA0870
C                           BY THE PROGRAM.)                             9CA0880
C                      = 8  THIS IS A NON-EXECUTABLE INSTRUCTION NOTIFY- 9CA0890
C                           ING THE PROGRAM THAT NO TRANSFORMATION IS TO 9CA0900
C                           BE APPLIED TO THIS CELL.  THIS INSTRUCTION   9CA0910
C                           CARD MAY BE USED FOR ONE OF TWO PURPOSES.    9CA0920
C                           (A) TO CALCULATE THE INVERSE CELL DATA OF    9CA0930
C                           THE INPUT PARAMETERS, VOLUME AND SIN AND COS 9CA0940
C                           VALUES OF CELL ANGLES, OR (B) TO IDENTIFY    9CA0950
C                           THE NAME OF THE CELL TO WHICH THE PREVIOUS   9CA0960
C                           CELL IS TRANSFORMED WHEN THE PREVIOUS CELL   9CA0970
C                           IN A TRANSFORMATION SEQUENCE INVOLVES ANY    9CA0980
C                           ONE OF THE FOLLOWING INSTRUCTIONS--NQ=1,2,3, 9CA0990
C                           4,5 OR 6.                                    9CA1000
C                                                                        9CA1010
C       COL. 6-80  CELL     ANY ALPHANUMERIC INFORMATION DESCRIBING THE  9CA1020
C                           CELL, E.G., CRYSTAL SYSTEM AND LATTICE TYPE. 9CA1030
C                           LEFT JUSTIFY.  THIS WILL BE PRINTED BACK OUT 9CA1040
C                           AS A HEADING IN THE OUTPUT FOR IDENTIFICA-   9CA1050
C                           TION PURPOSES.                               9CA1060
C                                                                        9CA1070
C  5. TRANSFORMATION CARDS -- FORMAT(9F8.5).                             9CA1080
C                                                                        9CA1090
C          EACH CARD CONTAINS A 3X3 TRANSFORMATION MATRIX (ONE PER CARD) 9CA1100
C          TO BE USED BY THE PROGRAM FOR EACH INSTRUCTION CARD WITH NQ=1 9CA1110
C          AND ARE ARRANGED IN THE SAME ORDER AS ARE THE INSTRUCTION     9CA1120
C          CARDS (WITH NQ=1) WHICH WILL USE THEM.  IF NO INSTRUCTION     9CA1130
C          CARDS ARE PRESENT WITH NQ=1, THESE TRANSFORMATION CARDS ARE   9CA1140
C          OMITTED.                                                      9CA1150
C          (EXAMPLE.  INSTRUCTION CARD NO. 1 HAS NQ=1 AND CARD NO. 2     9CA1160
C          HAS NQ=8.  INSTR. CARD NO. 1 CORRESP. TO CELL NO. 1 AND       9CA1170
C          INSTR. CARD NO. 2 CORRESP. TO CELL NO. 2.  ONE MATRIX CARD    9CA1180
C          IS THEREFORE SUPPLIED WHICH IS USED BY THE PROGRAM TO         9CA1190
C          TRANSFORM CELL 1 TO CELL 2.)                                  9CA1200
C          THE 3X3 MATRIX FOR VECTOR TRANSFORMATION OF UNIT CELL AXES    9CA1210
C          IS DEFINED BY THE USUAL CONVENTION AS FOLLOWS                 9CA1220
C                   NEWA = P(1,1)*A + P(1,2)*B + P(1,3)*C                9CA1230
C                   NEWB = P(2,1)*A + P(2,2)*B + P(2,3)*C                9CA1240
C                   NEWC = P(3,1)*A + P(3,2)*B + P(3,3)*C                9CA1250
C          WHERE A,B,C,NEWA,NEWB,NEWC ARE VECTORS DESCRIBING THE OLD AND 9CA1260
C          NEW CELL RESPECTIVELY.  THE ORDER OF PUNCHING IS P(1,1),      9CA1270
C          P(1,2),P(1,3),P(2,1),P(2,2),P(2,3),P(3,1),P(3,2),P(3,3).      9CA1280
C                                                                        9CA1290
C  6. STOPPER CARD -- 1 IN COL. 72                                       9CA1300
C                                                                        9CA1310
C          ANY NUMBER OF SETS OF DATA MAY BE PROCESSED WITHOUT RELOADING 9CA1320
C          THE PROGRAM.  EACH DATA SET CONSISTS OF ITEMS 1 - 5 ABOVE.    9CA1330
C                                                                        9CA1340
C     GLOSSARY OF SYMBOLS FOR MAIN PROGRAM AND SUBROUTINES RCELL,        9CA1350
C     LATCON, STORE, DIMEN, MATIN, MATOFC, CENTER                        9CA1360
C                                                                        9CA1370
C     A          DIRECT CELL PARAMETER, A                                9CA1380
C     AA         A*A                                                     9CA1390
C     AB         A*B*COSGA = SCALAR PRODUCT OF A WITH B                  9CA1400
C     ABSAB      ABS(AB)                                                 9CA1410
C     ABSBC      ABS(BC)                                                 9CA1420
C     ABSCA      ABS(CA)                                                 9CA1430
C     AL         DIRECT CELL PARAMETER, ALPHA, IN RADIANS                9CA1440
C     ALPHA      DIRECT CELL PARAMETER, ALPHA, IN DEGREES                9CA1450
C     ALS        RECIPROCAL CELL PARAMETER, ALPHA-STAR, IN RADIANS       9CA1460
C     ALSTAR     RECIPROCAL CELL PARAMETER, ALPHA-STAR, IN DEGREES       9CA1470
C     ANGLE(3)   DIRECT CELL PARAMETERS ALPHA, BETA, GAMMA IN NEW CELL   9CA1480
C     AS         RECIPROCAL CELL PARAMETER, A-STAR                       9CA1490
C     AXIS(3)    DIRECT CELL PARAMETERS A, B, C OF NEW CELL              9CA1500
C     B          DIRECT CELL PARAMETER, B                                9CA1510
C     BB         B*B                                                     9CA1520
C     BC         B*C*COSAL = SCALAR PRODUCT OF B WITH C                  9CA1530
C     BE         DIRECT CELL PARAMETER, BETA, IN RADIANS                 9CA1540
C     BES        RECIPROCAL CELL PARAMETER, BETA-STAR, IN RADIANS        9CA1550
C     BESTAR     RECIPROCAL CELL PARAMETER, BETA-STAR, IN DEGREES        9CA1560
C     BET        MODULUS OF TRANSF. MATRIX FOR CELL(N+1) TO CELL(N)      9CA1570
C     BETA       DIRECT CELL PARAMETER, BETA, IN DEGREES                 9CA1580
C     BS         RECIPROCAL CELL PARAMETER, B-STAR                       9CA1590
C     C          DIRECT CELL PARAMETER, C                                9CA1600
C     CA         C*A*COSBE = SCALAR PRODUCT OF C WITH A                  9CA1610
C     CC         C*C                                                     9CA1620
C     CELL(15,12)   ANY ALPHANUMERIC INFORMATION DESCRIBING THE CELL     9CA1630
C     CSE(3)     COSINE OF NEW ALPHA, BETA, GAMMA                        9CA1640
C     COSAL      COS(AL)                                                 9CA1650
C     COSALS     COS(ALS)                                                9CA1660
C     COSBE      COS(BE)                                                 9CA1670
C     COSBES     COS(BES)                                                9CA1680
C     COSGA      COS(GA)                                                 9CA1690
C     COSGAS     COS(GAS)                                                9CA1700
C     CS         RECIPROCAL CELL PARAMETER, C-STAR                       9CA1710
C     D(3)       DIRECT CELL PARAMETERS A, B, C IN NEW ORIENTED CELL     9CA1720
C     DET        MODULUS OF TRANSF. MATRIX FOR CELL(N) TO CELL(N+1)      9CA1730
C     DIS(6,12)  STORAGE LOCATIONS FOR A, B, C, ALPHA, BETA, GAMMA       9CA1740
C     GA         DIRECT CELL PARAMETER, GAMMA, IN RADIANS                9CA1750
C     GAMMA      DIRECT CELL PARAMETER, GAMMA, IN DEGREES                9CA1760
C     GAS        RECIPROCAL CELL PARAMETER, GAMMA-STAR, IN RADIANS       9CA1770
C     GASTAR     RECIPROCAL CELL PARAMETER, GAMMA-STAR, IN DEGREES       9CA1780
C     I          INDEX                                                   9CA1790
C     IAXIS      AXIS (VECTOR) HELD CONSTANT. 1=A, 2=B, 3=C              9CA1800
C     ICONT      CONTINUATION/STOPPER CODE FOR NEXT JOB                  9CA1810
C     ICYCLE     NUMBER OF CYCLES IN REDUCED CELL ROUTINE                9CA1820
C     IHKL(12)   CODE FOR PROGRAM SECTION                                9CA1830
C     INPUT      SPECIFICATION CODE FOR CELL PARAMETERS READ AT INPUT    9CA1840
C     IOUTPT     PROGRAM SECTION NUMBER                                  9CA1850
C     IS         CODE FOR USE IN SUBR. LATCON                            9CA1860
C     ISIGN      NUMBER OF ACUTE ANGLES IN REDUCED CELL                  9CA1870
C     ISUM       ITOTAL (+2, IF NQ(ITOTAL)=7)                            9CA1880
C     ITL        ITOTAL (+1, IF NQ(ITOTAL)=7)                            9CA1890
C     ITOTAL     TOTAL NUMBER OF CELL IDENTIFICATION CARDS READ IN       9CA1900
C     ITT        SECTION IDENTIFICATION IN SUBR. TEST                    9CA1910
C     J          INDEX                                                   9CA1920
C     J1         ITOTAL + 1                                              9CA1930
C     J2         ITOTAL + 2                                              9CA1940
C     JA         CODE FOR SHIFT IN A-AXIS.  JA=0 NO SHIFT, JA=1 SHIFT    9CA1950
C     JB         CODE FOR SHIFT IN B-AXIS.  JB=0 NO SHIFT, JB=1 SHIFT    9CA1960
C     JB2        INDEX                                                   9CA1970
C     JC         CODE FOR SHIFT IN C-AXIS.  JC=0 NO SHIFT, JC=1 SHIFT    9CA1980
C     JF         JA + JB + JC                                            9CA1990
C     JJ         INDEX                                                   9CA2000
C     JL         INDEX                                                   9CA2010
C     K          INDEX                                                   9CA2020
C     K2         CODE FOR REDUCTION OF REMAINING TWO AXES                9CA2030
C     K4         INDEX IDENT. FOR MATRIX IN SUBR. MATIN AND MATOFC       9CA2040
C     K8         STORAGE FOR K                                           9CA2050
C     KK         CODE FOR PARAMETERS IN CONVENTIONAL CELL. 1=A, 2=B, 3=C 9CA2060
C     KX         INDEX                                                   9CA2070
C     L          INDEX                                                   9CA2080
C     L2         INDEX                                                   9CA2090
C     LINE       PAGE CONTROL FOR OUTPUT                                 9CA2100
C     LL         INDEX                                                   9CA2110
C     LM         INDEX                                                   9CA2120
C     LOC        ERROR IDENTIFICATION IN SUBROUTINE RCELL                9CA2130
C     M          INDEX                                                   9CA2140
C     MA         SECTION IDENTIFICATION IN SUBR. MATOFC                  9CA2150
C     MATRIX     NUMBER OF TRANSFORMATION CARDS READ IN                  9CA2160
C     MAX        LARGEST CELL PARAMETER READ AT INPUT. 1=A, 4=B, 7=C     9CA2170
C     MM(3,3,3)  MATRIX ELEMENTS (IN FIXED PT.) FOR CELL(N+1) TO CELL(N) 9CA2180
C     N(9)       ELEMENTS OF DIRECT TRANSFORMATION MATRIX TO RED. CELL   9CA2190
C     NA(9)      MATRIX ELEMENTS OF CELL(N) TO CELL(N+1) IN SUBR. RCELL  9CA2200
C     NB(9)      MATRIX ELEMENTS OF CELL(1) TO CELL(N+1) IN SUBR. RCELL  9CA2210
C     NCHECK     INDEX CONTROLLING REDUCTION OF CELL PARAMETER           9CA2220
C     NN(3,3,3)  MATRIX ELEMENTS (IN FIXED PT.) FOR CELL(N) TO CELL(N+1) 9CA2230
C     NQ(12)     TRANSFORMATION INSTRUCTION CODE                         9CA2240
C     NSTOP      INDEX CONTROL. WHEN NSTOP = 3, REDUCTION CYCLE COMPLETE 9CA2250
C     NTEMP(9)   TEMPORARY STORAGE LOCATION FOR MATRIX ELEMENTS          9CA2260
C     NTURN      INDEX CONTROL                                           9CA2270
C     P(3,3,3)   MATRIX ELEMENTS (IN FLOATING POINT)                     9CA2280
C     PN         INTEGER (FLOATING PT.)                                  9CA2290
C     Q(3,3,12)  MATRIX ELEMENTS (IN FLOATING POINT)                     9CA2300
C     QMAX       THE LARGER OF TWO CELL PARAMETERS                       9CA2310
C     QQMAX      THE LARGEST OF (ABSAB, ABSBC, ABSCA)                    9CA2320
C     S(3,3,14)  MATRIX ELEMENTS (IN FLOAT PT.) FOR CELL(N+1) TO CELL(N) 9CA2330
C     SINAL      SIN(AL)                                                 9CA2340
C     SINALS     SIN(ALS)                                                9CA2350
C     SINBE      SIN(BE)                                                 9CA2360
C     SINBES     SIN(BES)                                                9CA2370
C     SINGA      SIN(GA)                                                 9CA2380
C     SINGAS     SIN(GAS)                                                9CA2390
C     STORE      TEMPORARY STORAGE LOCATION FOR NEW SCALAR PRODUCT       9CA2400
C     SUM        BC + CA + AB                                            9CA2410
C     TITLE(14)  ALPHANUMERIC TITLE READ AT START OF PROGRAM             9CA2420
C     V          CELL VOLUME IN DIRECT SPACE                             9CA2430
C     VS         CELL VOLUME IN RECIPROCAL SPACE                         9CA2440
C     W(3,3,12)  MATRIX ELEMENTS OF ORIGNAL CELL TO FINAL CELL           9CA2450
C     X          TEMPORARY LOCATION FOR CELL PARAMETER A, B OR C         9CA2460
C     XX         X*X                                                     9CA2470
C     XY         TEMPORARY LOCATION FOR SCALAR PRODUCT AB, BC OR CA      9CA2480
C     XY2        TEMPORARY LOCATION OF NEW SCALAR PRODUCT                9CA2490
C     Y          TEMPORARY LOCATION FOR CELL PARAMETER A, B OR C         9CA2500
C     YY         Y*Y                                                     9CA2510
C     YZ         TEMPORARY LOCATION FOR SCALAR PRODUCT AB, BC OR CA      9CA2520
C     Z          TEMPORARY LOCATION FOR CELL PARAMETER A, B OR C         9CA2530
C     ZX         TEMPORARY LOCATION FOR SCALAR PRODUCT AB, BC OR CA      9CA2540
C     ZX2        TEMPORARY LOCATION OF NEW SCALAR PRODUCT                9CA2550
C     ZZ         Z*Z                                                     9CA2560
C                                                                        9CA2570
C     MAIN PROGRAM.  INPUT/OUTPUT ROUTINE AND CALLING PROGRAM FOR        9CA2580
C     INSTRUCTIONS NQ.                                                   9CA2590
C                                                                        9CA2600
      DIMENSION TITLE(35),NQ(12),CELL(25,12),P(3,3,12),IHKL(12),         9CA2610
     1 DIS(6,12),NN(3,3,3),MM(3,3,4),S(3,3,15),DET(15),BET(15)           9CA2620
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CA2630
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CA2640
      COMMON SINAL,SINBE,SINGA,ALS,BES,GAS,SINALS,SINBES,SINGAS,COSALS,  9CA2650
     1 COSBES,COSGAS,AS,BS,CS,AL,BE,GA,ALSTAR,BESTAR,GASTAR,V,VS         9CA2660
C                                                                        9CA2670
C          FORMAT STATEMENTS                                             9CA2680
C                                                                        9CA2690
 1000 FORMAT (35A2,I2)                                                   9CA2700
 1001 FORMAT (I3,F7.3)                                                   9CA2710
 1002 FORMAT (6F10.6)                                                    9CA2720
 1003 FORMAT (I3,2X,25A3)                                                9CA2730
 1004 FORMAT (9F8.5)                                                     9CA2740
 1006 FORMAT (1H1,//5X,35A2 / )                                          9CA2750
 1009 FORMAT (1H0/ 4X, 40H LATTICES USED AND GENERATED BY PROGRAM  / )   9CA2760
 1010 FORMAT (1H , 9X, 7H CELL (,I1,4H)   , 25A3)                        9CA2770
 1011 FORMAT (1H , 9X, 7H CELL (,I1,16H)   REDUCED CELL)                 9CA2780
 1012 FORMAT (1H , 9X, 7H CELL (,I1,43H)   REDUCED CELL (CONVENTIONAL OR 9CA2790
     1IENTATION))                                                        9CA2800
 1018 FORMAT (1H0//4X,25H TRANSFORMATION MATRICES / )                    9CA2810
 1019 FORMAT (1H0/,13X, 7H CELL (,I1,11H) TO CELL (,I1,1H),              9CA2820
     1             12X, 7H CELL (,I1,11H) TO CELL (,I1,1H) // )          9CA2830
 1020 FORMAT (1H , 11X, 3F7.2, 12X, 3F7.2 / )                            9CA2840
 1021 FORMAT (1H0/,13X, 19H CELL (1) TO CELL (,I1,1H),                   9CA2850
     1             12X,  7H CELL (,I1,13H) TO CELL (1) // )              9CA2860
 1023 FORMAT (1H0/,10X,29H LATTICE PARAMETERS OF CELL (,I1,5H) -- ,25A3) 9CA2870
 1024 FORMAT (1H0/,16X, 6H A  = F9.4, 14X, 10H ALPHA  = F10.4)           9CA2880
 1025 FORMAT (1H , 15X, 6H B  = F9.4, 14X, 10H BETA   = F10.4)           9CA2890
 1026 FORMAT (1H , 15X, 6H C  = F9.4, 14X, 10H GAMMA  = F10.4)           9CA2900
 1027 FORMAT (1H0, 15X, 6H A* = F9.6, 14X, 10H ALPHA* = F10.4)           9CA2910
 1028 FORMAT (1H , 15X, 6H B* = F9.6, 14X, 10H BETA * = F10.4)           9CA2920
 1029 FORMAT (1H , 15X, 6H C* = F9.6, 14X, 10H GAMMA* = F10.4)           9CA2930
 1030 FORMAT (1H0, 15X, 6H V  = F9.3)                                    9CA2940
 1031 FORMAT (1H , 15X, 6H V* = F9.6, // )                               9CA2950
 1032 FORMAT (1H0/,10X,44H NATURAL TRIGONOMETRIC VALUES OF THE ANGLES )  9CA2960
 1033 FORMAT (1H0/,29X, 7H ANGLE , 6X, 5H SIN , 7X, 5H COS )             9CA2970
 1034 FORMAT (1H0, 15X, 7H ALPHA , F13.4, 2F12.5)                        9CA2980
 1035 FORMAT (1H , 15X, 7H BETA  , F13.4, 2F12.5)                        9CA2990
 1036 FORMAT (1H , 15X, 7H GAMMA , F13.4, 2F12.5)                        9CA3000
 1037 FORMAT (1H0/,16X, 7H ALPHA*, F13.4, 2F12.5)                        9CA3010
 1038 FORMAT (1H , 15X, 7H BETA *, F13.4, 2F12.5)                        9CA3020
 1039 FORMAT (1H , 15X, 7H GAMMA*, F13.4, 2F12.5)                        9CA3030
 1040 FORMAT (1H0//10X,44H SCALARS CORRESPONDING TO THIS REDUCED CELL  ) 9CA3040
 1041 FORMAT (1H0/,16X, 9H R(1,1) = F7.2, 5X, 9H R(2,2) = F7.2, 5X,      9CA3050
     1                  9H R(3,3) = F7.2)                                9CA3060
 1042 FORMAT (1H0, 15X, 9H R(2,3) = F7.2, 5X, 9H R(3,1) = F7.2, 5X,      9CA3070
     1                  9H R(1,2) = F7.2)                                9CA3080
 1043 FORMAT (1H0/,16X, 28H R(2,3) + R(3,1) + R(1,2)  =  F7.2)           9CA3090
 1044 FORMAT (1H , 16X, 3I4, 21X, 3I4 / )                                9CA3100
 1045 FORMAT (1H0/,10X,29H LATTICE PARAMETERS OF CELL (,I1,44H) -- REDUC 9CA3110
     1ED CELL (CONVENTIONAL ORIENTATION))                                9CA3120
 1046 FORMAT (1H , 16X, 6H MOD = F8.4, 19X, 6H MOD = F8.4 / )            9CA3130
 1048 FORMAT (1H0/,10X,29H LATTICE PARAMETERS OF CELL (,I1,17H) -- REDUC 9CA3140
     1ED CELL)                                                           9CA3150
 1070 FORMAT (I1)                                                        9CA3160
C                                                                        9CA3170
C          INPUT                                                         9CA3180
C                                                                        9CA3190
    1 READ 1000, (TITLE(I), I = 1,35), ICONT                             9CA3200
      IF (ICONT) 89,2,89                                                 9CA3210
    2 READ 1001, INPUT, DEL                                              9CA3220
      GO TO (61, 62), INPUT                                              9CA3230
   61 READ 1002, A, B, C, ALPHA, BETA, GAMMA                             9CA3240
      IS = 1                                                             9CA3250
      GO TO 70                                                           9CA3260
   62 READ 1002, AS, BS, CS, ALSTAR, BESTAR, GASTAR                      9CA3270
      IS = 3                                                             9CA3280
   70 ITOTAL = 0                                                         9CA3290
      MATRIX = 0                                                         9CA3300
   71 ITOTAL = ITOTAL + 1                                                9CA3310
      READ 1003, NQ(ITOTAL), (CELL(I,ITOTAL),I=1,25)                     9CA3320
      IF (NQ(ITOTAL).EQ.1) GO TO 72                                      9CA3330
      GO TO 73                                                           9CA3340
   72 MATRIX = MATRIX + 1                                                9CA3350
   73 I = NQ(ITOTAL)                                                     9CA3360
      GO TO (71,71,71,71,71,71,74,75), I                                 9CA3370
   74 ISUM = ITOTAL + 2                                                  9CA3380
      ITL = ITOTAL + 1                                                   9CA3390
      GO TO 76                                                           9CA3400
   75 ISUM = ITOTAL                                                      9CA3410
      ITL = ITOTAL                                                       9CA3420
   76 IF (MATRIX) 600, 600, 78                                           9CA3430
   78 DO 83 K = 1,ITOTAL                                                 9CA3440
      IF (NQ(K).NE.1) GO TO 83                                           9CA3450
      READ 1004, ((P(I,J,K), J = 1,3), I = 1,3)                          9CA3460
   83 CONTINUE                                                           9CA3470
      K = 1                                                              9CA3480
      K4 = 1                                                             9CA3490
      CALL MATIN(K4)                                                     9CA3500
C                                                                        9CA3510
C          PRELIMINARY OUTPUT                                            9CA3520
C                                                                        9CA3530
  600 IOUTPT = 1                                                         9CA3540
      ICYCLE = 0                                                         9CA3550
      K = 1                                                              9CA3560
      IHKL(1) = 1                                                        9CA3570
      CALL LATCON(IS)                                                    9CA3580
      CALL STORE                                                         9CA3590
      IF (NQ(1).EQ.8) GO TO 742                                          9CA3600
   64 PRINT 1006, (TITLE(I), I = 1,35)                                   9CA3610
      PRINT 1009                                                         9CA3620
      DO 13 J = 1,ITOTAL                                                 9CA3630
   13 PRINT 1010, J, (CELL(I,J), I = 1,25)                               9CA3640
      IF (NQ(ITOTAL).EQ.7) GO TO 14                                      9CA3650
      GO TO 113                                                          9CA3660
   14 J1 = ITOTAL + 1                                                    9CA3670
      J2 = ITOTAL + 2                                                    9CA3680
      PRINT 1011, J1                                                     9CA3690
      PRINT 1012, J2                                                     9CA3700
C                                                                        9CA3710
C          CALL DESIRED TRANSFORMATION SUBROUTINE                        9CA3720
C                                                                        9CA3730
  113 I = NQ(K)                                                          9CA3740
      GO TO (5001,5000,5000,5000,5000,5000,5002), I                      9CA3750
 5000 CALL CENTER(K,NQ,P)                                                9CA3760
      K4 = 1                                                             9CA3770
      CALL MATIN(K4)                                                     9CA3780
 5001 CALL DIMEN                                                         9CA3790
      IS = 1                                                             9CA3800
      CALL LATCON (IS)                                                   9CA3810
      CALL STORE                                                         9CA3820
      IF (K - 1) 64,64,63                                                9CA3830
   63 IF (ISUM - K) 41,41,113                                            9CA3840
 5002 CALL RCELL                                                         9CA3850
   41 MA = 1                                                             9CA3860
      CALL MATOFC(MA,K4,ITL)                                             9CA3870
C                                                                        9CA3880
C          FINAL OUTPUT                                                  9CA3890
C                                                                        9CA3900
   68 IOUTPT = 3                                                         9CA3910
      IF (NQ(ITOTAL).EQ.8) GO TO 69                                      9CA3920
      LINE = 0                                                           9CA3930
      ITT = 1                                                            9CA3940
      CALL TEST(ITT,LINE)                                                9CA3950
   69 PRINT 1018                                                         9CA3960
      K = 1                                                              9CA3970
      IF (ISUM - 5) 798, 799, 799                                        9CA3980
  798 LINE = 2                                                           9CA3990
      GO TO 800                                                          9CA4000
  799 LINE = 3                                                           9CA4010
  800 I = NQ(K)                                                          9CA4020
      GO TO (750,750,750,750,750,750,751), I                             9CA4030
  750 KX = K + 1                                                         9CA4040
      PRINT 1019, K, KX, KX, K                                           9CA4050
      PRINT 1020, P(1,1,K),P(1,2,K),P(1,3,K), S(1,1,K),S(1,2,K),S(1,3,K) 9CA4060
      PRINT 1020, P(2,1,K),P(2,2,K),P(2,3,K), S(2,1,K),S(2,2,K),S(2,3,K) 9CA4070
      PRINT 1020, P(3,1,K),P(3,2,K),P(3,3,K), S(3,1,K),S(3,2,K),S(3,3,K) 9CA4080
      PRINT 1046, DET(K), BET(K)                                         9CA4090
      GO TO 755                                                          9CA4100
  751 L = 1                                                              9CA4110
      KX = K + 1                                                         9CA4120
      PRINT 1019, K, KX, KX, K                                           9CA4130
      PRINT 1044, NN(1,1,L),NN(1,2,L),NN(1,3,L), MM(1,1,L),MM(1,2,L),    9CA4140
     1            MM(1,3,L)                                              9CA4150
      PRINT 1044, NN(2,1,L),NN(2,2,L),NN(2,3,L), MM(2,1,L),MM(2,2,L),    9CA4160
     1            MM(2,3,L)                                              9CA4170
      PRINT 1044, NN(3,1,L),NN(3,2,L),NN(3,3,L), MM(3,1,L),MM(3,2,L),    9CA4180
     1            MM(3,3,L)                                              9CA4190
      PRINT 1046, DET(K), BET(K)                                         9CA4200
      LINE = LINE + 1                                                    9CA4210
      IF (LINE - 5) 752, 743, 743                                        9CA4220
  743 LINE = 1                                                           9CA4230
      PRINT 1006, (TITLE(I), I = 1,35)                                   9CA4240
  752 L = 2                                                              9CA4250
      KX = K + 2                                                         9CA4260
      PRINT 1019, K, KX, KX, K                                           9CA4270
      PRINT 1044, NN(1,1,L),NN(1,2,L),NN(1,3,L), MM(1,1,L),MM(1,2,L),    9CA4280
     1            MM(1,3,L)                                              9CA4290
      PRINT 1044, NN(2,1,L),NN(2,2,L),NN(2,3,L), MM(2,1,L),MM(2,2,L),    9CA4300
     1            MM(2,3,L)                                              9CA4310
      PRINT 1044, NN(3,1,L),NN(3,2,L),NN(3,3,L), MM(3,1,L),MM(3,2,L),    9CA4320
     1            MM(3,3,L)                                              9CA4330
      PRINT 1046, DET(K+1), BET(K+1)                                     9CA4340
  755 LINE = LINE + 1                                                    9CA4350
      IF (LINE - 5) 741, 740, 740                                        9CA4360
  740 LINE = 1                                                           9CA4370
      PRINT 1006, (TITLE(I), I = 1,35)                                   9CA4380
  741 K = K + 1                                                          9CA4390
      IF (ITL - K) 753, 753, 800                                         9CA4400
  753 IF (ITL - 3) 754, 757, 757                                         9CA4410
  754 IF (NQ(1).EQ.7) GO TO 746                                          9CA4420
      GO TO 742                                                          9CA4430
  757 IF (NQ(ITOTAL).EQ.8) GO TO 747                                     9CA4440
  746 ITT = 2                                                            9CA4450
      CALL TEST(ITT,LINE)                                                9CA4460
      IF (NQ(1).EQ.7) GO TO 758                                          9CA4470
  747 PRINT 1021, ITL,ITL                                                9CA4480
      PRINT 1020, P(1,1,L2),P(1,2,L2),P(1,3,L2), S(1,1,L2),S(1,2,L2),    9CA4490
     1            S(1,3,L2)                                              9CA4500
      PRINT 1020, P(2,1,L2),P(2,2,L2),P(2,3,L2), S(2,1,L2),S(2,2,L2),    9CA4510
     1            S(2,3,L2)                                              9CA4520
      PRINT 1020, P(3,1,L2),P(3,2,L2),P(3,3,L2), S(3,1,L2),S(3,2,L2),    9CA4530
     1            S(3,3,L2)                                              9CA4540
      PRINT 1046, DET(L2), BET(L2)                                       9CA4550
      IF (ICYCLE) 742, 742, 758                                          9CA4560
  758 K4 = 4                                                             9CA4570
      JB2 = ITL - 1                                                      9CA4580
      DO 7771 I = 1,3                                                    9CA4590
      DO 7771 J = 1,3                                                    9CA4600
 7771 P(I,J,JB2) = NN(I,J,2)                                             9CA4610
      MA = 2                                                             9CA4620
      IF (NQ(1).EQ.7) L2 = 2                                             9CA4630
      IF (NQ(1).EQ.7) GO TO 762                                          9CA4640
      CALL MATOFC(MA,K4,ITL)                                             9CA4650
 7772 LINE = LINE + 1                                                    9CA4660
      IF (LINE - 5) 761, 760, 760                                        9CA4670
  760 LINE = 1                                                           9CA4680
      PRINT 1006, (TITLE(I), I = 1,35)                                   9CA4690
  761 PRINT 1021, ISUM, ISUM                                             9CA4700
      PRINT 1020, P(1,1,L2),P(1,2,L2),P(1,3,L2), S(1,1,L2),S(1,2,L2),    9CA4710
     1            S(1,3,L2)                                              9CA4720
      PRINT 1020, P(2,1,L2),P(2,2,L2),P(2,3,L2), S(2,1,L2),S(2,2,L2),    9CA4730
     1            S(2,3,L2)                                              9CA4740
      PRINT 1020, P(3,1,L2),P(3,2,L2),P(3,3,L2), S(3,1,L2),S(3,2,L2),    9CA4750
     1            S(3,3,L2)                                              9CA4760
      PRINT 1046, DET(L2), BET(L2)                                       9CA4770
  762 ITT = 3                                                            9CA4780
      CALL TEST(ITT,LINE)                                                9CA4790
C                                                                        9CA4800
  742 J = 0                                                              9CA4810
  756 J = J + 1                                                          9CA4820
      PRINT 1006, (TITLE(I), I = 1,35)                                   9CA4830
      IF (IHKL(J) - 2) 771,772,773                                       9CA4840
  771 PRINT 1023, J, (CELL(I,J),I=1,25)                                  9CA4850
      GO TO 774                                                          9CA4860
  772 PRINT 1048, J                                                      9CA4870
      GO TO 774                                                          9CA4880
  773 PRINT 1045, J                                                      9CA4890
  774 A = DIS(1,J)                                                       9CA4900
      B = DIS(2,J)                                                       9CA4910
      C = DIS(3,J)                                                       9CA4920
      ALPHA = DIS(4,J)                                                   9CA4930
      BETA  = DIS(5,J)                                                   9CA4940
      GAMMA = DIS(6,J)                                                   9CA4950
      IS = 1                                                             9CA4960
      CALL LATCON(IS)                                                    9CA4970
  777 PRINT 1024, A, ALPHA                                               9CA4980
      PRINT 1025, B, BETA                                                9CA4990
      PRINT 1026, C, GAMMA                                               9CA5000
      PRINT 1027, AS, ALSTAR                                             9CA5010
      PRINT 1028, BS, BESTAR                                             9CA5020
      PRINT 1029, CS, GASTAR                                             9CA5030
      PRINT 1030, V                                                      9CA5040
      PRINT 1031, VS                                                     9CA5050
C                                                                        9CA5060
      PRINT 1032                                                         9CA5070
      PRINT 1033                                                         9CA5080
      PRINT 1034, ALPHA, SINAL, COSAL                                    9CA5090
      PRINT 1035, BETA,  SINBE, COSBE                                    9CA5100
      PRINT 1036, GAMMA, SINGA, COSGA                                    9CA5110
      PRINT 1037, ALSTAR, SINALS, COSALS                                 9CA5120
      PRINT 1038, BESTAR, SINBES, COSBES                                 9CA5130
      PRINT 1039, GASTAR, SINGAS, COSGAS                                 9CA5140
C                                                                        9CA5150
      IF (NQ(1).EQ.8) GO TO 1                                            9CA5160
      I = IHKL(J)                                                        9CA5170
      GO TO (208, 871, 871, 1), I                                        9CA5180
C                                                                        9CA5190
  871 PRINT 1040                                                         9CA5200
      AA = A*A                                                           9CA5210
      BB = B*B                                                           9CA5220
      CC = C*C                                                           9CA5230
      AB = A*B*COSGA                                                     9CA5240
      BC = B*C*COSAL                                                     9CA5250
      CA = C*A*COSBE                                                     9CA5260
      SUM = AB + BC + CA                                                 9CA5270
      PRINT 1041, AA, BB, CC                                             9CA5280
      PRINT 1042, BC, CA, AB                                             9CA5290
      PRINT 1043, SUM                                                    9CA5300
C                                                                        9CA5310
  208 IF (ISUM - J) 890, 890, 756                                        9CA5320
  890 IF (NQ(ITOTAL).EQ.8) GO TO 1                                       9CA5330
      ITT = 4                                                            9CA5340
      J = JSUM                                                           9CA5350
      IHKL(J) = 4                                                        9CA5360
      CALL TEST(ITT,LINE)                                                9CA5370
      IS = 1                                                             9CA5380
      CALL LATCON(IS)                                                    9CA5390
      GO TO 777                                                          9CA5400
   89 STOP                                                               9CA5410
      END                                                                9CA5420
      SUBROUTINE RCELL                                                   9CB0030
C                                                                        9CB0040
C     TRANSFORM GIVEN CELL TO REDUCED CELL.  CALLED WHEN INSTRUCTION     9CB0050
C     NQ = 7.                                                            9CB0060
C                                                                        9CB0070
      DIMENSION N(9),NA(9),NB(9),D(3),ANGLE(3),NN(3,3,3),P(3,3,12),      9CB0080
     1 S(3,3,15),MM(3,3,4),IHKL(12),NTEMP(9)                             9CB0090
      DIMENSION TITLE(35),DIS(6,12),DET(15),BET(15)                      9CB0100
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CB0110
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CB0120
      COMMON SINAL,SINBE,SINGA,ALS,BES,GAS,SINALS,SINBES,SINGAS,COSALS, A9CB0121
     1 COSBES,COSGAS,AS,BS,CS,AL,BE,GA,ALSTAR,BESTAR,GASTAR,V,VS        A9CB0122
C                                                                        9CB0130
C          PART 1.  TRANSFORMATION.                                      9CB0140
C                                                                        9CB0150
C                                                                        9CB0160
      K = K + 1                                                          9CB0170
      IHKL(K) = 2                                                        9CB0180
      ICYCLE = 1                                                         9CB0190
      AB = A * B * COSGA                                                 9CB0200
      BC = B * C * COSAL                                                 9CB0210
      CA = C * A * COSBE                                                 9CB0220
      DO 175 J = 1,9                                                     9CB0230
      N(J) = 0                                                           9CB0240
  175 NA(J) = 0                                                          9CB0250
      N(1) = 1                                                           9CB0260
      N(5) = 1                                                           9CB0270
      N(9) = 1                                                           9CB0280
      NA(1) = 1                                                          9CB0290
      NA(5) = 1                                                          9CB0300
      NA(9) = 1                                                          9CB0310
  382 NSTOP = 1                                                          9CB0320
      K2 = 0                                                             9CB0330
      ABSAB = ABS(AB)                                                    9CB0340
      ABSBC = ABS(BC)                                                    9CB0350
      ABSCA = ABS(CA)                                                    9CB0360
      QQMAX = AMAX1(ABSAB, ABSBC, ABSCA)                                 9CB0370
      IF (QQMAX - ABSAB) 176, 401, 176                                   9CB0380
  176 IF (QQMAX - ABSBC) 177, 404, 407                                   9CB0390
  177 LOC = 7                                                            9CB0400
      GO TO 890                                                          9CB0410
  401 QMAX = AMAX1(A,B)                                                  9CB0420
      IF (QMAX - A) 84, 91, 92                                           9CB0430
  404 QMAX = AMAX1(B,C)                                                  9CB0440
      IF (QMAX - B) 84, 93, 94                                           9CB0450
  407 QMAX = AMAX1(C,A)                                                  9CB0460
      IF (QMAX - C) 84, 95, 96                                           9CB0470
   91 IAXIS = 2                                                          9CB0480
      GO TO 1                                                            9CB0490
   92 IAXIS = 1                                                          9CB0500
      GO TO 4                                                            9CB0510
   93 IAXIS = 3                                                          9CB0520
      GO TO 4                                                            9CB0530
   94 IAXIS = 2                                                          9CB0540
      GO TO 7                                                            9CB0550
   95 IAXIS = 1                                                          9CB0560
      GO TO 7                                                            9CB0570
   96 IAXIS = 3                                                          9CB0580
      GO TO 1                                                            9CB0590
C                                                                        9CB0600
    1 MAX = 1                                                            9CB0610
      GO TO 10                                                           9CB0620
    2 IAXIS = 1                                                          9CB0630
      QMAX = AMAX1(B,C)                                                  9CB0640
      IF (QMAX - B) 87, 101, 102                                         9CB0650
  101 K2 = 1                                                             9CB0660
      GO TO 30                                                           9CB0670
  102 K2 = 2                                                             9CB0680
      GO TO 50                                                           9CB0690
    3 IF (K2 - 1) 88, 121, 122                                           9CB0700
  121 IAXIS = 2                                                          9CB0710
      GO TO 50                                                           9CB0720
  122 IAXIS = 3                                                          9CB0730
    4 MAX = 4                                                            9CB0740
      GO TO 30                                                           9CB0750
    5 IAXIS = 2                                                          9CB0760
      QMAX = AMAX1(A,C)                                                  9CB0770
      IF (QMAX - A) 87, 201, 202                                         9CB0780
  201 K2 = 1                                                             9CB0790
      GO TO 10                                                           9CB0800
  202 K2 = 2                                                             9CB0810
      GO TO 50                                                           9CB0820
    6 IF (K2 - 1) 88, 123, 124                                           9CB0830
  123 IAXIS = 1                                                          9CB0840
      GO TO 50                                                           9CB0850
  124 IAXIS = 3                                                          9CB0860
      GO TO 10                                                           9CB0870
C                                                                        9CB0880
    7 MAX = 7                                                            9CB0890
      GO TO 50                                                           9CB0900
    8 IAXIS = 3                                                          9CB0910
      QMAX = AMAX1(A,B)                                                  9CB0920
      IF (QMAX - A) 87, 301, 302                                         9CB0930
  301 K2 = 1                                                             9CB0940
      GO TO 10                                                           9CB0950
  302 K2 = 2                                                             9CB0960
      GO TO 30                                                           9CB0970
    9 IF (K2 - 1) 88, 125, 126                                           9CB0980
  125 IAXIS = 1                                                          9CB0990
      GO TO 30                                                           9CB1000
  126 IAXIS = 2                                                          9CB1010
      GO TO 10                                                           9CB1020
   84 LOC = 1                                                            9CB1030
      GO TO 890                                                          9CB1040
   87 LOC = 2                                                            9CB1050
      GO TO 890                                                          9CB1060
   88 LOC = 3                                                            9CB1070
      GO TO 890                                                          9CB1080
C                                                                        9CB1090
C          REDUCTION OF A.   (QMAX = A)                                  9CB1100
C                                                                        9CB1110
   10 X  = A                                                             9CB1120
      Y  = B                                                             9CB1130
      Z  = C                                                             9CB1140
      XY = AB                                                            9CB1150
      YZ = BC                                                            9CB1160
      ZX = CA                                                            9CB1170
C                                                                        9CB1180
      NCHECK = 1                                                         9CB1190
      GO TO (85, 11, 12), IAXIS                                          9CB1200
   11 I = 2                                                              9CB1210
      GO TO 100                                                          9CB1220
   12 I = 3                                                              9CB1230
      GO TO 300                                                          9CB1240
C                                                                        9CB1250
   15 A  = X                                                             9CB1260
      B  = Y                                                             9CB1270
      C  = Z                                                             9CB1280
      AB = XY                                                            9CB1290
      BC = YZ                                                            9CB1300
      CA = ZX                                                            9CB1310
C                                                                        9CB1320
      NCHECK = NCHECK - 1                                                9CB1330
      IF (NCHECK) 46, 17, 17                                             9CB1340
   17 IF (I - 2) 86, 12, 11                                              9CB1350
   46 MAX = MAX + 1                                                      9CB1360
      NSTOP = NSTOP + 1                                                  9CB1370
      IF (NSTOP - 3) 18, 18, 601                                         9CB1380
   18 GO TO (1, 2, 3, 4, 5, 6, 7, 8, 9), MAX                             9CB1390
C                                                                        9CB1400
C          REDUCTION OF B.   (QMAX = B)                                  9CB1410
C                                                                        9CB1420
   30 X  = B                                                             9CB1430
      Y  = C                                                             9CB1440
      Z  = A                                                             9CB1450
      XY = BC                                                            9CB1460
      YZ = CA                                                            9CB1470
      ZX = AB                                                            9CB1480
C                                                                        9CB1490
      NCHECK = 1                                                         9CB1500
      GO TO (32, 85, 31), IAXIS                                          9CB1510
   31 I = 6                                                              9CB1520
      GO TO 100                                                          9CB1530
   32 I = 4                                                              9CB1540
      GO TO 300                                                          9CB1550
C                                                                        9CB1560
   35 A  = Z                                                             9CB1570
      B  = X                                                             9CB1580
      C  = Y                                                             9CB1590
      AB = ZX                                                            9CB1600
      BC = XY                                                            9CB1610
      CA = YZ                                                            9CB1620
C                                                                        9CB1630
      NCHECK = NCHECK - 1                                                9CB1640
      IF (NCHECK) 46, 37, 37                                             9CB1650
   37 IF (I - 4) 86, 31, 32                                              9CB1660
C                                                                        9CB1670
C          REDUCTION OF C.   (QMAX = C)                                  9CB1680
C                                                                        9CB1690
   50 X  = C                                                             9CB1700
      Y  = A                                                             9CB1710
      Z  = B                                                             9CB1720
      XY = CA                                                            9CB1730
      YZ = AB                                                            9CB1740
      ZX = BC                                                            9CB1750
C                                                                        9CB1760
      NCHECK = 1                                                         9CB1770
      GO TO (51, 52, 85), IAXIS                                          9CB1780
   51 I = 7                                                              9CB1790
      GO TO 100                                                          9CB1800
   52 I = 8                                                              9CB1810
      GO TO 300                                                          9CB1820
C                                                                        9CB1830
   55 A  = Y                                                             9CB1840
      B  = Z                                                             9CB1850
      C  = X                                                             9CB1860
      AB = YZ                                                            9CB1870
      BC = ZX                                                            9CB1880
      CA = XY                                                            9CB1890
C                                                                        9CB1900
      NCHECK = NCHECK - 1                                                9CB1910
      IF (NCHECK) 46, 57, 57                                             9CB1920
   57 IF (I - 7) 86, 52, 51                                              9CB1930
C                                                                        9CB1940
   85 LOC = 4                                                            9CB1950
      GO TO 890                                                          9CB1960
   86 LOC = 5                                                            9CB1970
      GO TO 890                                                          9CB1980
C                                                                        9CB1990
C          REDUCTION OF X.  ABSF(X.Y) GREATER THAN (Y**2)/2              9CB2000
C                                                                        9CB2010
  100 XX = X*X                                                           9CB2020
      YY = Y*Y                                                           9CB2030
      PN = 0.                                                            9CB2040
      IF (ABS(XY) - 0.5*YY) 444, 444, 110                                9CB2050
  110 IF (XY) 120, 444, 200                                              9CB2060
  120 XY2 = XY + PN*YY                                                   9CB2070
      IF (XY2) 130, 150, 150                                             9CB2080
  130 SAVE = XY2                                                         9CB2090
      PN = PN + 1.                                                       9CB2100
      GO TO 110                                                          9CB2110
  150 IF (ABS(XY2) - ABS(SAVE)) 143, 142, 142                            9CB2120
  142 PN = PN - 1.                                                       9CB2130
  143 NA(I) = PN                                                         9CB2140
      X = SQRT(XX + 2.*PN*XY + PN*PN*YY)                                 9CB2150
      ZX = ZX + PN*YZ                                                    9CB2160
  144 IF (ABS(XY2) - ABS(SAVE)) 160, 170, 170                            9CB2170
  160 XY = XY2                                                           9CB2180
      GO TO 520                                                          9CB2190
  170 XY = SAVE                                                          9CB2200
      GO TO 520                                                          9CB2210
C                                                                        9CB2220
  200 XY2 = XY - PN*YY                                                   9CB2230
      IF (XY2) 250, 250, 230                                             9CB2240
  230 SAVE = XY2                                                         9CB2250
      PN = PN + 1.                                                       9CB2260
      GO TO 200                                                          9CB2270
  250 IF (ABS(XY2) - ABS(SAVE)) 243, 243, 242                            9CB2280
  242 PN = PN - 1.                                                       9CB2290
  243 NA(I) = -PN                                                        9CB2300
      X = SQRT(XX - 2.*PN*XY + PN*PN*YY)                                 9CB2310
      ZX = ZX - PN*YZ                                                    9CB2320
      GO TO 144                                                          9CB2330
C                                                                        9CB2340
C          REDUCTION OF X.  ABSF(Z.X) GREATER THAN (Z**2)/2              9CB2350
C                                                                        9CB2360
  300 XX = X*X                                                           9CB2370
      ZZ = Z*Z                                                           9CB2380
      PN = 0.                                                            9CB2390
      IF  (ABS(ZX) - 0.5 * ZZ) 444, 444, 310                             9CB2400
  310 IF (ZX) 320, 444, 400                                              9CB2410
  320 ZX2 = ZX + PN*ZZ                                                   9CB2420
      IF (ZX2) 330, 350, 350                                             9CB2430
  330 SAVE = ZX2                                                         9CB2440
      PN = PN + 1.                                                       9CB2450
      GO TO 310                                                          9CB2460
  350 IF (ABS(ZX2) - ABS(SAVE)) 343, 342, 342                            9CB2470
  342 PN = PN - 1.                                                       9CB2480
  343 NA(I) = PN                                                         9CB2490
      X =  SQRT(XX + 2.*PN*ZX + PN*PN*ZZ)                                9CB2500
      XY = XY + PN*YZ                                                    9CB2510
  344 IF (ABS(ZX2) - ABS(SAVE)) 360, 370, 370                            9CB2520
  360 ZX = ZX2                                                           9CB2530
      GO TO 520                                                          9CB2540
  370 ZX = SAVE                                                          9CB2550
      GO TO 520                                                          9CB2560
C                                                                        9CB2570
  400 ZX2 = ZX - PN*ZZ                                                   9CB2580
      IF (ZX2) 450, 450, 430                                             9CB2590
  430 SAVE = ZX2                                                         9CB2600
      PN = PN + 1.                                                       9CB2610
      GO TO 400                                                          9CB2620
  450 IF (ABS(ZX2) - ABS(SAVE)) 463, 463, 462                            9CB2630
  462 PN = PN - 1.                                                       9CB2640
  463 NA(I) = -PN                                                        9CB2650
      X =  SQRT(XX - 2.*PN*ZX + PN*PN*ZZ)                                9CB2660
      XY = XY - PN*YZ                                                    9CB2670
      GO TO 344                                                          9CB2680
C                                                                        9CB2690
  520 NB(1) = NA(1)*N(1) + NA(2)*N(4) + NA(3)*N(7)                       9CB2700
      NB(2) = NA(1)*N(2) + NA(2)*N(5) + NA(3)*N(8)                       9CB2710
      NB(3) = NA(1)*N(3) + NA(2)*N(6) + NA(3)*N(9)                       9CB2720
      NB(4) = NA(4)*N(1) + NA(5)*N(4) + NA(6)*N(7)                       9CB2730
      NB(5) = NA(4)*N(2) + NA(5)*N(5) + NA(6)*N(8)                       9CB2740
      NB(6) = NA(4)*N(3) + NA(5)*N(6) + NA(6)*N(9)                       9CB2750
      NB(7) = NA(7)*N(1) + NA(8)*N(4) + NA(9)*N(7)                       9CB2760
      NB(8) = NA(7)*N(2) + NA(8)*N(5) + NA(9)*N(8)                       9CB2770
      NB(9) = NA(7)*N(3) + NA(8)*N(6) + NA(9)*N(9)                       9CB2780
      DO 521 J = 1,9                                                     9CB2790
      N(J) = NB(J)                                                       9CB2800
      IF (N(J)) 521, 540, 521                                            9CB2810
  540 N(J) = 0                                                           9CB2820
  521 NA(J) = 0                                                          9CB2830
      NA(1) = 1                                                          9CB2840
      NA(5) = 1                                                          9CB2850
      NA(9) = 1                                                          9CB2860
  444 GO TO (601, 15, 15, 35, 601, 35, 55, 55, 601), I                   9CB2870
C                                                                        9CB2880
C                                                                        9CB2890
C          OUTPUT OF PART 1.    (REDUCED CELL)                           9CB2900
C                                                                        9CB2910
C                                                                        9CB2920
  601 COSAL = BC / (B*C)                                                 9CB2930
      COSBE = CA / (C*A)                                                 9CB2940
      COSGA = AB / (A*B)                                                 9CB2950
      AL =  ACOS(COSAL)                                                  9CB2960
      BE =  ACOS(COSBE)                                                  9CB2970
      GA =  ACOS(COSGA)                                                  9CB2980
      SINAL = SIN(AL)                                                    9CB2990
      SINBE = SIN(BE)                                                    9CB3000
      SINGA = SIN(GA)                                                    9CB3010
      ALPHA = 57.295780 * AL                                             9CB3020
      BETA  = 57.295780 * BE                                             9CB3030
      GAMMA = 57.295780 * GA                                             9CB3040
      LL = 1                                                             9CB3050
      GO TO 602                                                          9CB3060
C                                                                        9CB3070
C          A TEST IS NOW MADE TO DETERMINE IF THE CELL JUST OBTAINED     9CB3080
C     IS THE REDUCED CELL.  IF ONE OR MORE OF THE AXES CAN BE FURTHER    9CB3090
C     REDUCED, THE PROGRAM RETURNS TO STMNT 382 FOR ANOTHER CYCLE.       9CB3100
C                                                                        9CB3110
  501 IF  (ABS(AB) - 0.5 * A*A) 502, 502, 381                            9CB3120
  502 IF  (ABS(AB) - 0.5 * B*B) 503, 503, 381                            9CB3130
  503 IF  (ABS(BC) - 0.5 * B*B) 504, 504, 381                            9CB3140
  504 IF  (ABS(BC) - 0.5 * C*C) 505, 505, 381                            9CB3150
  505 IF  (ABS(CA) - 0.5 * C*C) 506, 506, 381                            9CB3160
  506 IF  (ABS(CA) - 0.5 * A*A) 66, 66, 381                              9CB3170
  381 ICYCLE = ICYCLE + 1                                                9CB3180
      GO TO 382                                                          9CB3190
C                                                                        9CB3200
C                                                                        9CB3210
C          PART 2.   TRANSFORMATION OF REDUCED CELL TO CONVENTIONAL      9CB3220
C     REDUCED CELL.  THE CONVENTION IS C LESS THAN A LESS THAN B,        9CB3230
C     WITH ALPHA, BETA OBTUSE.                                           9CB3240
C                                                                        9CB3250
C                                                                        9CB3260
   66 JA = 0                                                             9CB3270
      JB = 0                                                             9CB3280
      JC = 0                                                             9CB3290
      K = K + 1                                                          9CB3300
      IHKL(K) = 3                                                        9CB3310
      NTURN = 1                                                          9CB3320
      KK = 3                                                             9CB3330
      IF (AMIN1(A,B,C) - A) 702, 611, 999                                9CB3340
  611 JJ = 7                                                             9CB3350
      M = -6                                                             9CB3360
      GO TO 721                                                          9CB3370
  702 IF (AMIN1(A,B,C) - B) 612, 613, 999                                9CB3380
  612 JC = 1                                                             9CB3390
      JJ = 7                                                             9CB3400
      M = 0                                                              9CB3410
      GO TO 723                                                          9CB3420
  613 JJ = 7                                                             9CB3430
      M = -3                                                             9CB3440
      GO TO 722                                                          9CB3450
  703 NTURN = 2                                                          9CB3460
      KK = 2                                                             9CB3470
      IF (AMAX1(A,B,C) - A) 999, 614, 704                                9CB3480
  614 IF (AMIN1(A,B,C).EQ.A) GO TO 704                                   9CB3490
      JJ = 4                                                             9CB3500
      M = -3                                                             9CB3510
      GO TO 721                                                          9CB3520
  704 IF (AMAX1(A,B,C) - B) 999, 615, 616                                9CB3530
  615 JB = 1                                                             9CB3540
      JJ = 4                                                             9CB3550
      M = 0                                                              9CB3560
      GO TO 722                                                          9CB3570
  616 JJ = 4                                                             9CB3580
      M = 3                                                              9CB3590
      GO TO 723                                                          9CB3600
  706 NTURN = 3                                                          9CB3610
      KK = 1                                                             9CB3620
      IF (D(2) - A) 710, 707, 710                                        9CB3630
  710 IF (D(2) - B) 999, 708, 709                                        9CB3640
  707 IF (AMIN1(B,C) - B) 622, 621, 999                                  9CB3650
  621 JJ = 1                                                             9CB3660
      M = 6                                                              9CB3670
      GO TO 723                                                          9CB3680
  622 JJ = 1                                                             9CB3690
      M = 3                                                              9CB3700
      GO TO 722                                                          9CB3710
  708 IF (AMIN1(A,C) - A) 623, 621, 999                                  9CB3720
  623 JA = 1                                                             9CB3730
      JJ = 1                                                             9CB3740
      M = 0                                                              9CB3750
      GO TO 721                                                          9CB3760
  709 IF (AMIN1(A,B) - A) 623, 622, 999                                  9CB3770
C                                                                        9CB3780
  999 LOC = 6                                                            9CB3790
      GO TO 890                                                          9CB3800
C                                                                        9CB3810
  721 D(KK) = A                                                          9CB3820
      ANGLE (KK) = ALPHA                                                 9CB3830
  664 JL = JJ + 2                                                        9CB3840
      DO 665 L = JJ,JL                                                   9CB3850
      LM = L + M                                                         9CB3860
  665 NTEMP(L) = N(LM)                                                   9CB3870
      GO TO (703, 706, 739), NTURN                                       9CB3880
  722 D(KK) = B                                                          9CB3890
      ANGLE (KK) = BETA                                                  9CB3900
      GO TO 664                                                          9CB3910
  723 D(KK) = C                                                          9CB3920
      ANGLE (KK) = GAMMA                                                 9CB3930
      GO TO 664                                                          9CB3940
C                                                                        9CB3950
  739 DO 730 I = 1,9                                                     9CB3960
  730 N(I) = NTEMP(I)                                                    9CB3970
      A = D(1)                                                           9CB3980
      B = D(2)                                                           9CB3990
      C = D(3)                                                           9CB4000
      ALPHA = ANGLE(1)                                                   9CB4010
      BETA  = ANGLE(2)                                                   9CB4020
      GAMMA = ANGLE(3)                                                   9CB4030
C                                                                        9CB4040
C          THE FOLLOWING SECTION CHECKS TO MAKE SURE ALPHA AND BETA ARE  9CB4050
C     EACH EQUAL TO OR GREATER THAN 90 DEGREES.  IF ONE OR BOTH ARE      9CB4060
C     LESS THAN 90 DEGREES, THE PROPER ADJUSTMENTS ARE MADE.             9CB4070
C                                                                        9CB4080
  223 LL = 2                                                             9CB4090
      ISIGS = 0                                                          9CB4100
      IF (ALPHA - 90.0) 21, 801, 801                                     9CB4110
   21 ISIGS = ISIGS + 1                                                  9CB4120
  801 IF (BETA - 90.0) 22, 802, 802                                      9CB4130
   22 ISIGS = ISIGS + 1                                                  9CB4140
  802 IF (ISIGS - 1) 602, 69, 79                                         9CB4150
C                                                                        9CB4160
C     ISIGS = 1                                                          9CB4170
C          EITHER ALPHA OR BETA IS LESS THAN 90 DEGREES.  REDEFINE THAT  9CB4180
C          ANGLE AS ITS SUPPLEMENT AND SET GAMMA = 180.0 - GAMMA.        9CB4190
C          (TWO ANGLES MUST ALWAYS BE TRANSFORMED SIMULTANEOUSLY.)       9CB4200
C                                                                        9CB4210
   69 GAMMA = 180.0 - GAMMA                                              9CB4220
      DO 6661 I = 7,9                                                    9CB4230
      N(I) = -N(I)                                                       9CB4240
      IF (N(I)) 6661, 4441, 6661                                         9CB4250
 4441 N(I) = 0                                                           9CB4260
 6661 CONTINUE                                                           9CB4270
      IF (ALPHA - 90.0) 43, 44, 44                                       9CB4280
   43 ALPHA = 180.0 - ALPHA                                              9CB4290
      DO 6662 I = 1,3                                                    9CB4300
      N(I) = -N(I)                                                       9CB4310
      IF (N(I)) 6662, 4442, 6662                                         9CB4320
 4442 N(I) = 0                                                           9CB4330
 6662 CONTINUE                                                           9CB4340
      GO TO 602                                                          9CB4350
   44 BETA = 180.0 - BETA                                                9CB4360
      DO 6663 I = 4,6                                                    9CB4370
      N(I) = -N(I)                                                       9CB4380
      IF (N(I)) 6663, 4443, 6663                                         9CB4390
 4443 N(I) = 0                                                           9CB4400
 6663 CONTINUE                                                           9CB4410
      GO TO 602                                                          9CB4420
C                                                                        9CB4430
C     ISIGS = 2                                                          9CB4440
C          REDEFINE ALPHA AND BETA AS ITS OWN SUPPLEMENT AND REVERSE THE 9CB4450
C          DIRECTIONS OF A AND B.                                        9CB4460
C                                                                        9CB4470
   79 ALPHA = 180.0 - ALPHA                                              9CB4480
      BETA = 180.0 - BETA                                                9CB4490
      DO 6664 I = 1,6                                                    9CB4500
      N(I) = -N(I)                                                       9CB4510
      IF (N(I)) 6664, 4444, 6664                                         9CB4520
 4444 N(I) = 0                                                           9CB4530
 6664 CONTINUE                                                           9CB4540
C                                                                        9CB4550
  602 GO TO (821, 831), LL                                               9CB4560
C                                                                        9CB4570
C          A CHECK IS MADE TO DETERMINE IF THE SYSTEM HAS GONE FROM      9CB4580
C     RIGHT-HANDED TO LEFT-HANDED OR VICE VERSA.  IF JF = 1 THE SYSTEM   9CB4590
C     HAS REVERSED.  IF JF = 0 OR 3, IT HAS NOT REVERSED.                9CB4600
C                                                                        9CB4610
  831 JF = JA + JB + JC                                                  9CB4620
      IF (JF - 1) 821, 832, 821                                          9CB4630
  832 DO 835 I = 1,9                                                     9CB4640
      N(I) = -N(I)                                                       9CB4650
      IF (N(I)) 835, 833, 835                                            9CB4660
  833 N(I) = 0                                                           9CB4670
  835 CONTINUE                                                           9CB4680
C                                                                        9CB4690
  821 K = K - 1                                                          9CB4700
      L = 0                                                              9CB4710
      DO 822 I = 1,3                                                     9CB4720
      DO 822 J = 1,3                                                     9CB4730
      L = L + 1                                                          9CB4740
      NN(I,J,LL) = N(L)                                                  9CB4750
  822 P(I,J,K) = N(L)                                                    9CB4760
      K4 = 2                                                             9CB4770
      CALL MATIN(K4)                                                     9CB4780
      L = 0                                                              9CB4790
      DO 823 I = 1,3                                                     9CB4800
      DO 823 J = 1,3                                                     9CB4810
      L = L + 1                                                          9CB4820
  823 MM(I,J,LL) = S(I,J,K)                                              9CB4830
      K = K + 1                                                          9CB4840
      IF (IHKL(K) - 2) 261,261,260                                       9CB4850
  260 IS = 1                                                             9CB4860
      GO TO 262                                                          9CB4870
  261 IS = 2                                                             9CB4880
  262 CALL LATCON(IS)                                                    9CB4890
      CALL STORE                                                         9CB4900
      I = IHKL(K)                                                        9CB4910
      IF (I.EQ.2) GO TO 501                                              9CB4920
      GO TO 41                                                           9CB4930
C                                                                        9CB4940
  890 PRINT 1000, LOC                                                    9CB4950
 1000 FORMAT (1H0//,51H AN ERROR HAS OCCURRED IN SUBROUTINE RCELL.   LOC 9CB4960
     1 = I2)                                                             9CB4970
C                                                                        9CB4980
   41 RETURN                                                             9CB4990
      END                                                                9CB5000
      SUBROUTINE LATCON(IS)                                              9CC0030
C                                                                        9CC0040
C     CALCULATE CELL PARAMETER DATA IN DIRECT AND RECIPROCAL SPACE       9CC0050
C                                                                        9CC0060
      DIMENSION TITLE(35),P(3,3,12),IHKL(12),DIS(6,12),NN(3,3,3),        9CC0070
     1 MM(3,3,4),S(3,3,15),DET(15),BET(15)                               9CC0080
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CC0090
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CC0100
      COMMON SINAL,SINBE,SINGA,ALS,BES,GAS,SINALS,SINBES,SINGAS,COSALS,  9CC0110
     1 COSBES,COSGAS,AS,BS,CS,AL,BE,GA,ALSTAR,BESTAR,GASTAR,V,VS         9CC0120
C                                                                        9CC0130
      GO TO (71,81,72), IS                                               9CC0140
   71 SINAL = SIN(ALPHA * 1.745329E-02)                                  9CC0150
      SINBE = SIN(BETA  * 1.745329E-02)                                  9CC0160
      SINGA = SIN(GAMMA * 1.745329E-02)                                  9CC0170
      COSAL = COS(ALPHA * 1.745329E-02)                                  9CC0180
      COSBE = COS(BETA  * 1.745329E-02)                                  9CC0190
      COSGA = COS(GAMMA * 1.745329E-02)                                  9CC0200
   81 ALS =  ACOS((COSBE * COSGA - COSAL) / (SINBE * SINGA))             9CC0210
      BES =  ACOS((COSAL * COSGA - COSBE) / (SINAL * SINGA))             9CC0220
      GAS =  ACOS((COSAL * COSBE - COSGA) / (SINAL * SINBE))             9CC0230
      SINALS = SIN(ALS)                                                  9CC0240
      SINBES = SIN(BES)                                                  9CC0250
      SINGAS = SIN(GAS)                                                  9CC0260
      COSALS = COS(ALS)                                                  9CC0270
      COSBES = COS(BES)                                                  9CC0280
      COSGAS = COS(GAS)                                                  9CC0290
      AS = 1. / (A * SINBES * SINGA)                                     9CC0300
      BS = 1. / (B * SINALS * SINGA)                                     9CC0310
      CS = 1. / (C * SINALS * SINBE)                                     9CC0320
      ALSTAR = ALS * 57.295780                                           9CC0330
      BESTAR = BES * 57.295780                                           9CC0340
      GASTAR = GAS * 57.295780                                           9CC0350
      GO TO 99                                                           9CC0360
C                                                                        9CC0370
   72 SINALS = SIN(ALSTAR * 1.745329E-02)                                9CC0380
      SINBES = SIN(BESTAR * 1.745329E-02)                                9CC0390
      SINGAS = SIN(GASTAR * 1.745329E-02)                                9CC0400
      COSALS = COS(ALSTAR * 1.745329E-02)                                9CC0410
      COSBES = COS(BESTAR * 1.745329E-02)                                9CC0420
      COSGAS = COS(GASTAR * 1.745329E-02)                                9CC0430
      AL =  ACOS((COSBES * COSGAS - COSALS) / (SINBES * SINGAS))         9CC0440
      BE =  ACOS((COSALS * COSGAS - COSBES) / (SINALS * SINGAS))         9CC0450
      GA =  ACOS((COSALS * COSBES - COSGAS) / (SINALS * SINBES))         9CC0460
      SINAL = SIN(AL)                                                    9CC0470
      SINBE = SIN(BE)                                                    9CC0480
      SINGA = SIN(GA)                                                    9CC0490
      COSAL = COS(AL)                                                    9CC0500
      COSBE = COS(BE)                                                    9CC0510
      COSGA = COS(GA)                                                    9CC0520
      A = 1. / (AS * SINBE * SINGAS)                                     9CC0530
      B = 1. / (BS * SINAL * SINGAS)                                     9CC0540
      C = 1. / (CS * SINAL * SINBES)                                     9CC0550
      ALPHA = AL * 57.295780                                             9CC0560
      BETA  = BE * 57.295780                                             9CC0570
      GAMMA = GA * 57.295780                                             9CC0580
C                                                                        9CC0590
   99 V  = A*B*C*SINAL*SINBE*SINGAS                                      9CC0600
      VS = 1./V                                                          9CC0610
      RETURN                                                             9CC0620
      END                                                                9CC0630
      SUBROUTINE STORE                                                   9CD0030
C                                                                        9CD0040
C     STORE CELL PARAMETERS INTO VARIABLE DIS(I,K)                       9CD0050
C                                                                        9CD0060
      DIMENSION TITLE(35),DIS(6,12),IHKL(12)                             9CD0070
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CD0080
C                                                                        9CD0090
      DIS(1,K) = A                                                       9CD0100
      DIS(2,K) = B                                                       9CD0110
      DIS(3,K) = C                                                       9CD0120
      DIS(4,K) = ALPHA                                                   9CD0130
      DIS(5,K) = BETA                                                    9CD0140
      DIS(6,K) = GAMMA                                                   9CD0150
C                                                                        9CD0160
      RETURN                                                             9CD0170
      END                                                                9CD0180
      SUBROUTINE DIMEN                                                   9CE0030
C                                                                        9CE0040
C     TRANSFORM GIVEN CELL (DEFINED BY VECTORS IN DIRECT SPACE) TO A     9CE0050
C     NEW CELL USING A VECTORIAL TRANSFORMATION MATRIX P(I,J,K).         9CE0060
C     CALLED IF NQ.LE.6.                                                 9CE0070
C                                                                        9CE0080
      DIMENSION AXIS(3),CSE(3),ANGLE(3),P(3,3,12),TITLE(35),DIS(6,12),   9CE0090
     1          IHKL(12)                                                 9CE0100
      DIMENSION S(3,3,15),DET(15),BET(15),NN(3,3,3),MM(3,3,4)            9CE0110
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CE0120
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CE0130
C                                                                        9CE0140
C          CALCULATION OF THE NEW A, B, C                                9CE0150
C                                                                        9CE0160
      DO 117 I = 1,3                                                     9CE0170
  117 AXIS(I) = SQRT((P(I,1,K)*A)**2 + (P(I,2,K)*B)**2 + (P(I,3,K)*C)**2 9CE0180
     1         + 2.*(P(I,1,K)*P(I,2,K)*A*B*COSGA                         9CE0190
     2         +     P(I,1,K)*P(I,3,K)*A*C*COSBE                         9CE0200
     3         +     P(I,2,K)*P(I,3,K)*B*C*COSAL))                       9CE0210
C                                                                        9CE0220
C          CALCULATION OF THE NEW ALPHA, BETA, GAMMA                     9CE0230
C                                                                        9CE0240
      J = 2                                                              9CE0250
      L = 3                                                              9CE0260
      DO 19 I = 1,3                                                      9CE0270
      CSE(I) = (P(J,1,K)*P(L,1,K)*A*A + P(J,2,K)*P(L,2,K)*B*B            9CE0280
     1         + P(J,3,K)*P(L,3,K)*C*C                                   9CE0290
     2         + (P(J,1,K)*P(L,2,K) + P(J,2,K)*P(L,1,K))*A*B*COSGA       9CE0300
     3         + (P(J,1,K)*P(L,3,K) + P(J,3,K)*P(L,1,K))*A*C*COSBE       9CE0310
     4         + (P(J,2,K)*P(L,3,K) + P(J,3,K)*P(L,2,K))*B*C*COSAL)      9CE0320
     5         / (AXIS(J)*AXIS(L))                                       9CE0330
      ANGLE(I) =  ACOS(CSE(I)) * 57.295780                               9CE0340
      GO TO (115, 16, 19), I                                             9CE0350
  115 J = 1                                                              9CE0360
      GO TO 19                                                           9CE0370
   16 L = 2                                                              9CE0380
   19 CONTINUE                                                           9CE0390
      A = AXIS(1)                                                        9CE0400
      B = AXIS(2)                                                        9CE0410
      C = AXIS(3)                                                        9CE0420
      ALPHA = ANGLE(1)                                                   9CE0430
      BETA  = ANGLE(2)                                                   9CE0440
      GAMMA = ANGLE(3)                                                   9CE0450
C                                                                        9CE0460
      K = K + 1                                                          9CE0470
      IHKL(K) = 1                                                        9CE0480
      RETURN                                                             9CE0490
      END                                                                9CE0500
      SUBROUTINE MATIN(K4)                                               9CF0030
C                                                                        9CF0040
C     GENERATE MATRIX ELEMENTS OF INVERSE TRANSFORMATION MATRIX          9CF0050
C                                                                        9CF0060
      DIMENSION P(3,3,12),S(3,3,15),DET(15),BET(15),TITLE(35),DIS(6,12), 9CF0070
     1 NN(3,3,3),MM(3,3,4),IHKL(12)                                      9CF0080
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CF0090
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CF0100
C                                                                        9CF0110
      GO TO (5552,5552,5553,5553), K4                                    9CF0120
 5552 L = K                                                              9CF0130
      GO TO 5554                                                         9CF0140
 5553 L = L2                                                             9CF0150
 5554 DET(L) = P(1,1,L)*(P(2,2,L)*P(3,3,L) - P(3,2,L)*P(2,3,L))          9CF0160
     1       - P(1,2,L)*(P(2,1,L)*P(3,3,L) - P(3,1,L)*P(2,3,L))          9CF0170
     2       + P(1,3,L)*(P(2,1,L)*P(3,2,L) - P(3,1,L)*P(2,2,L))          9CF0180
      S(1,1,L) =  (P(2,2,L)*P(3,3,L) - P(3,2,L)*P(2,3,L)) / DET(L)       9CF0190
      S(1,2,L) = -(P(1,2,L)*P(3,3,L) - P(3,2,L)*P(1,3,L)) / DET(L)       9CF0200
      S(1,3,L) =  (P(1,2,L)*P(2,3,L) - P(2,2,L)*P(1,3,L)) / DET(L)       9CF0210
      S(2,1,L) = -(P(2,1,L)*P(3,3,L) - P(3,1,L)*P(2,3,L)) / DET(L)       9CF0220
      S(2,2,L) =  (P(1,1,L)*P(3,3,L) - P(3,1,L)*P(1,3,L)) / DET(L)       9CF0230
      S(2,3,L) = -(P(1,1,L)*P(2,3,L) - P(2,1,L)*P(1,3,L)) / DET(L)       9CF0240
      S(3,1,L) =  (P(2,1,L)*P(3,2,L) - P(3,1,L)*P(2,2,L)) / DET(L)       9CF0250
      S(3,2,L) = -(P(1,1,L)*P(3,2,L) - P(3,1,L)*P(1,2,L)) / DET(L)       9CF0260
      S(3,3,L) =  (P(1,1,L)*P(2,2,L) - P(2,1,L)*P(1,2,L)) / DET(L)       9CF0270
      DO 5555 I = 1,3                                                    9CF0280
      DO 5555 J = 1,3                                                    9CF0290
      IF (S(I,J,L)) 5555, 5559, 5555                                     9CF0300
 5559 S(I,J,L) = 0.0                                                     9CF0310
 5555 CONTINUE                                                           9CF0320
      BET(L) = 1./DET(L)                                                 9CF0330
      IF (K4 - 1) 5558, 5556, 5558                                       9CF0340
 5556 IF (L - MATRIX) 5557, 5558, 5558                                   9CF0350
 5557 L = L + 1                                                          9CF0360
      GO TO 5554                                                         9CF0370
 5558 RETURN                                                             9CF0380
      END                                                                9CF0390
      SUBROUTINE MATOFC(MA,K4,ITL)                                       9CG0030
C                                                                        9CG0040
C     GENERATE MATRIX FOR VECTORIAL TRANSFORMATION OF LATTICE AXES OF    9CG0050
C     ORIGINAL CELL TO FINAL CELL WHEN BOTH CELLS ARE SEPARATED BY       9CG0060
C     INTERMEDIATE CELLS.  CALLED ONLY IF 3 OR MORE CELLS ARE INVOLVED   9CG0070
C     IN A SEQUENCE OF TRANSFORMATIONS.  IF A SERIES OF INSTRUCTIONS     9CG0080
C     ENDS WITH NQ = 8, MATOFC CALLED ONLY ONCE.  IF THE SERIES ENDS     9CG0090
C     WITH NQ = 7, MATOFC CALLED TWICE, ONCE FOR EACH OF THE TWO         9CG0100
C     ORIENTATIONS OF THE REDUCED CELL.  MATRIX OBTAINED BY MATRIX MULT. 9CG0110
C                                                                        9CG0120
      DIMENSION IHKL(12),Q(3,3,12),P(3,3,12),W(3,3,12)                   9CG0130
      DIMENSION TITLE(35),DIS(6,12),S(3,3,15),DET(15),BET(15),           9CG0140
     1 NN(3,3,3),MM(3,3,4)                                               9CG0150
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CG0160
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CG0170
C                                                                        9CG0180
      GO TO (41,8881), MA                                                9CG0190
   41 IF (ITL - 3) 68,45,45                                              9CG0200
   45 K4 = 3                                                             9CG0210
      K = K + 1                                                          9CG0220
      IHKL(K) = 4                                                        9CG0230
 8881 DO 8882 L = 1,ISUM                                                 9CG0240
      DO 8882 J = 1,3                                                    9CG0250
      DO 8882 I = 1,3                                                    9CG0260
 8882 Q(I,J,L) = P(I,J,L)                                                9CG0270
      IF (K4 - 4) 56, 58, 58                                             9CG0280
   56 K8 = K                                                             9CG0290
      GO TO 59                                                           9CG0300
   58 K = K8                                                             9CG0310
   59 IF (ICYCLE) 53, 53, 54                                             9CG0320
   53 K = K + 1                                                          9CG0330
   54 L = K - 3                                                          9CG0340
      M = K - 4                                                          9CG0350
      LL = L                                                             9CG0360
  104 DO 105 I = 1,3                                                     9CG0370
      DO 105 J = 1,3                                                     9CG0380
  105 W(I,J,L) = Q(I,1,L)*Q(1,J,M)+Q(I,2,L)*Q(2,J,M)+Q(I,3,L)*Q(3,J,M)   9CG0390
      IF (M - 1) 8890, 8890, 106                                         9CG0400
  106 DO 8883 I = 1,3                                                    9CG0410
      DO 8883 J = 1,3                                                    9CG0420
 8883 Q(I,J,L) = W(I,J,L)                                                9CG0430
      M = M - 1                                                          9CG0440
      GO TO 104                                                          9CG0450
 8890 IF (K4.EQ.3) GO TO 8892                                            9CG0460
 8891 L2 = L2 + 1                                                        9CG0470
      GO TO 8893                                                         9CG0480
 8892 L2 = ISUM                                                          9CG0490
 8893 DO 8887 I = 1,3                                                    9CG0500
      DO 8887 J = 1,3                                                    9CG0510
      P(I,J,L2) = W(I,J,L)                                               9CG0520
      IF (P(I,J,L2)) 8887,201,8887                                       9CG0530
  201 P(I,J,L2) = 0.0                                                    9CG0540
 8887 CONTINUE                                                           9CG0550
      CALL MATIN(K4)                                                     9CG0560
C                                                                        9CG0570
   68 RETURN                                                             9CG0580
      END                                                                9CG0590
      SUBROUTINE CENTER(K,NQ,P)                                          9CH0030
C                                                                        9CH0040
C     DEFINE MATRIX ELEMENTS FOR TRANSFORMATION OF AN A-, B-, C-, I- AND 9CH0050
C     F-CENTERED CELL TO A PRIMITIVE CELL                                9CH0060
C                                                                        9CH0070
      DIMENSION NQ(12),P(3,3,12),E(9)                                    9CH0080
C                                                                        9CH0090
      J = NQ(K)                                                          9CH0100
      DO 100 I = 1,9                                                     9CH0110
      GO TO (11,12,13,14,15,16,17,18,19), I                              9CH0120
C                                                                        9CH0130
   11 GO TO (9,5,3,4,5,4), J                                             9CH0140
   12 GO TO (9,3,3,4,3,4), J                                             9CH0150
   13 GO TO (9,3,1,3,3,3), J                                             9CH0160
   14 GO TO (9,3,3,1,3,3), J                                             9CH0170
   15 GO TO (9,4,5,3,5,4), J                                             9CH0180
   16 GO TO (9,4,3,3,3,4), J                                             9CH0190
   17 GO TO (9,3,4,3,4,4), J                                             9CH0200
   18 GO TO (9,1,3,3,4,3), J                                             9CH0210
   19 GO TO (9,3,4,5,4,4), J                                             9CH0220
C                                                                        9CH0230
    1 E(I) = -1.0                                                        9CH0240
      GO TO 100                                                          9CH0250
C   2 E(I) = -0.5                                                       P9CH0260
C     GO TO 100                                                         P9CH0270
    3 E(I) = 0.0                                                         9CH0280
      GO TO 100                                                          9CH0290
    4 E(I) = 0.5                                                         9CH0300
      GO TO 100                                                          9CH0310
    5 E(I) = 1.0                                                         9CH0320
  100 CONTINUE                                                           9CH0330
C                                                                        9CH0340
      L = 0                                                              9CH0350
      DO 200 I = 1,3                                                     9CH0360
      DO 200 J = 1,3                                                     9CH0370
      L = L + 1                                                          9CH0380
  200 P(I,J,K) = E(L)                                                    9CH0390
C                                                                        9CH0400
    9 RETURN                                                             9CH0410
      END                                                                9CH0420
      SUBROUTINE TEST(ITT,LINE)                                          9CJ0030
C                                                                        9CJ0040
C     ANALYZE SCALAR PRODUCTS OF REDUCED CELL (IN CONVENTIONAL ORIENTA-  9CJ0050
C     TION C.LT.A.LT.B, ALPHA, BETA OBTUSE) FOR UNIT CELL OF HIGHEST     9CJ0060
C     SYMMETRY.  MATRIX ELEMENTS EU(I) TAKEN FROM TABLE 3 OF - THE       9CJ0070
C     REDUCED CELL AND ITS CRYSTALLOGRAPHIC APPLICATIONS, U.S.A.E.C.,    9CJ0080
C     AMES LAB REPORT IS-1141, APRIL 1965, BY LAWTON AND JACOBSON.       9CJ0090
C                                                                        9CJ0100
C     GLOSSARY OF SYMBOLS.  REMAINING SYMBOLS DEFINED IN GLOSSARY        9CJ0110
C     PRECEDING MAIN PROGRAM.                                            9CJ0120
C                                                                        9CJ0130
C     A2       CELL PARAMETER, A, IN NEW UNIT CELL                       9CJ0140
C     ABC      A*B*COS(GAMMA)                                            9CJ0150
C     ACC      A*C*COS(BETA)                                             9CJ0160
C     ALPHA2   CELL PARAMETER, ALPHA, IN NEW UNIT CELL                   9CJ0170
C     B2       CELL PARAMETER, B, IN NEW UNIT CELL                       9CJ0180
C     BCC      B*C*COS(ALPHA)                                            9CJ0190
C     BETA2    CELL PARAMETER, BETA, IN NEW UNIT CELL                    9CJ0200
C     C2       CELL PARAMETER, C, IN NEW UNIT CELL                       9CJ0210
C     DEL      LARGEST EST. ERROR BETWEEN REDUCED CELL SCALAR PRODUCTS   9CJ0220
C     DETEU    MODULUS OF MATRIX EU                                      9CJ0240
C     DETEUI   MODULUS OF MATRIX EUI                                     9CJ0250
C     DETFN    MODULUS OF MATRIX F                                       9CJ0260
C     DETFNI   MODULUS OF MATRIX FI                                      9CJ0270
C     EU(9)    MATRIX ELEM. FOR TRANSF. OF CONV. RED. CELL TO UNIT CELL  9CJ0280
C     EUI(9)   INVERSE MATRIX ELEMENTS OF EU                             9CJ0290
C     F(9)     MATRIX ELEM. FOR TRANSF. OF ORIG. CELL TO UNIT CELL       9CJ0300
C     FI(9)    INVERSE MATRIX ELEMENTS OF F                              9CJ0310
C     GAMMA2   CELL PARAMETER, GAMMA, IN NEW UNIT CELL                   9CJ0320
C     ISYM     CODE IDENTIFYING EQUIVALENCY AMONG SYMMETRICAL SCALARS    9CJ0330
C     JSUM     ISUM + 1                                                  9CJ0340
C     JU       CODE IDENTIFYING SET OF UNSYMMETRICAL SCALAR PRODUCTS     9CJ0350
C     JU12     CODE FOR AB IN TEST FOR ZERO ELEMENT                      9CJ0360
C     JU23     CODE FOR BC IN TEST FOR ZERO ELEMENT                      9CJ0370
C     JU31     CODE FOR CA IN TEST FOR ZERO ELEMENT                      9CJ0380
C     ITT      CODE SPECIFYING SECTIONS OF SUBROUTINE TEST               9CJ0390
C                                                                        9CJ0400
      DIMENSION TITLE(35),DIS(6,12),IHKL(12),P(3,3,12),S(3,3,15),        9CJ0410
     1          DET(15),BET(15),NN(3,3,3),MM(3,3,4)                      9CJ0420
      DIMENSION EU(9),EUI(9),F(9),FI(9)                                  9CJ0430
      COMMON A,B,C,ALPHA,BETA,GAMMA,COSAL,COSBE,COSGA,TITLE,DIS,K,IHKL   9CJ0440
      COMMON DEL,ISUM,JSUM,P,S,DET,BET,L,L2,MATRIX,NN,MM,ICYCLE,IOUTPT   9CJ0450
C                                                                        9CJ0460
      GO TO (91,92,93,94), ITT                                           9CJ0470
C                                                                        9CJ0480
C          TEST R(1,1), R(2,2), R(3,3)                                   9CJ0490
C                                                                        9CJ0500
   91 AA = A * A                                                         9CJ0510
      BB = B * B                                                         9CJ0520
      CC = C * C                                                         9CJ0530
      BC = B * C * COSAL                                                 9CJ0540
      CA = C * A * COSBE                                                 9CJ0550
      AB = A * B * COSGA                                                 9CJ0560
      JU23 = 0                                                           9CJ0570
      JU31 = 0                                                           9CJ0580
      JU12 = 0                                                           9CJ0590
      JU = 0                                                             9CJ0600
C                                                                        9CJ0610
      IF (ABS(AA-BB) - DEL) 721,721,722                                  9CJ0620
  721 IF (ABS((AA+BB)/2. - CC) - DEL) 723,723,724                        9CJ0630
  723 ISYM = 1                                                           9CJ0640
      GO TO 100                                                          9CJ0650
  724 ISYM = 2                                                           9CJ0660
      GO TO 100                                                          9CJ0670
  722 IF (ABS(AA-CC) - DEL) 725,725,726                                  9CJ0680
  725 ISYM = 3                                                           9CJ0690
      GO TO 100                                                          9CJ0700
  726 IF (ABS(BB-CC) - DEL) 95,95,727                                    9CJ0710
  727 ISYM = 4                                                           9CJ0720
C                                                                        9CJ0730
C          TEST R(2,3), R(3,1), R(1,2)                                   9CJ0740
C                                                                        9CJ0750
C          1. TEST FOR ZERO ELEMENTS                                     9CJ0760
C                                                                        9CJ0770
  100 IF (ABS(ALPHA-90.0) - DEL) 102,102,101                             9CJ0780
  101 IF (ABS(BC) - DEL) 102,102,103                                     9CJ0790
  102 JU23 = 1                                                           9CJ0800
  103 IF (ABS(BETA-90.0) - DEL) 105,105,104                              9CJ0810
  104 IF (ABS(CA) - DEL) 105,105,106                                     9CJ0820
  105 JU31 = 1                                                           9CJ0830
  106 IF (ABS(GAMMA-90.0) - DEL) 108,108,107                             9CJ0840
  107 IF (ABS(AB) - DEL) 108,108,120                                     9CJ0850
  108 JU12 = 1                                                           9CJ0860
C                                                                        9CJ0870
  120 IF ((JU23+JU31+JU12).EQ.3) GO TO 130                               9CJ0880
      IF ((JU23+JU31).EQ.2) GO TO 140                                    9CJ0890
      IF ((JU23+JU12).EQ.2) GO TO 150                                    9CJ0900
      IF ((JU31+JU12).EQ.2) GO TO 160                                    9CJ0910
      IF (JU23.EQ.1) GO TO 170                                           9CJ0920
      IF (JU31.EQ.1) GO TO 180                                           9CJ0930
      IF (JU12.EQ.1) GO TO 240                                           9CJ0940
      GO TO 200                                                          9CJ0950
C                                                                        9CJ0960
C             R(2,3) = R(3,1) = R(1,2) = 0.0                             9CJ0970
C             CUBIC(41), TETRAGONAL(31), TETRAGONAL(30) AND              9CJ0980
C             ORTHORHOMBIC(19)                                           9CJ0990
C                                                                        9CJ1000
  130 GO TO (11,11,11,11),ISYM                                           9CJ1010
C                                                                        9CJ1020
C             R(2,3) = R(3,1) = 0.0                                      9CJ1030
C             HEXAGONAL(40A,B), ORTHORHOMBIC(24A,B), ORTHORHOMBIC(22A,B) 9CJ1040
C             AND MONOCLINIC(4A,B)                                       9CJ1050
C                                                                        9CJ1060
  140 IF (ABS(AB - AA/2.) - DEL) 141,141,142                             9CJ1070
  141 IF (ISYM.EQ.1) ISYM = 2                                            9CJ1080
      GO TO (98,12,98,12), ISYM                                          9CJ1090
  142 IF (ABS(AB + AA/2.) - DEL) 143,143,144                             9CJ1100
  143 IF (ISYM.EQ.1) ISYM = 2                                            9CJ1110
      GO TO (98,13,98,13), ISYM                                          9CJ1120
  144 IF (AB) 146,130,145                                                9CJ1130
  145 IF (ISYM.EQ.1) ISYM = 4                                            9CJ1140
      GO TO (98,14,98,14), ISYM                                          9CJ1150
  146 IF (ISYM.EQ.1) ISYM = 4                                            9CJ1160
      GO TO (98,15,98,15), ISYM                                          9CJ1170
C                                                                        9CJ1180
C             R(2,3) = R(1,2) = 0.0                                      9CJ1190
C             HEXAGONAL(39), ORTHORHOMBIC(23), ORTHORHOMBIC(20) AND      9CJ1200
C             MONOCLINIC(5)                                              9CJ1210
C                                                                        9CJ1220
  150 IF (ABS(CA + AA/2.) - DEL) 151,151,152                             9CJ1230
  151 IF (ISYM.EQ.1) ISYM = 3                                            9CJ1240
      GO TO (98,98,12,98), ISYM                                          9CJ1250
  152 IF (ISYM.EQ.3) GO TO 13                                            9CJ1260
      IF (ISYM.NE.4) GO TO 98                                            9CJ1270
      IF (ABS(CA + CC/2.) - DEL) 16,16,17                                9CJ1280
C                                                                        9CJ1290
C             R(3,1) = R(1,2) = 0.0                                      9CJ1300
C             ORTHORHOMBIC(21), MONOCLINIC(3) AND HEXAGONAL(SPECIAL      9CJ1310
C             CASE)                                                      9CJ1320
C                                                                        9CJ1330
  160 IF (ABS(BC + CC/2.) - DEL) 161,161,162                             9CJ1340
  161 GO TO (23,98,98,20), ISYM                                          9CJ1350
  162 GO TO (98,98,98,21), ISYM                                          9CJ1360
C                                                                        9CJ1370
C                                                                        9CJ1380
C             R(2,3) = 0.0     MONOCLINIC(9A,B)                          9CJ1390
C                                                                        9CJ1400
  170 IF (ISYM.NE.4) GO TO 98                                            9CJ1410
      IF (ABS(CA+CC/2.) - DEL) 171,171,98                                9CJ1420
  171 IF (AB) 19,150,18                                                  9CJ1430
C                                                                        9CJ1440
C             R(3,1) = 0.0                                               9CJ1450
C             TETRAGONAL(32A,B), ORTHORHOMBIC(27A,B), MONOCLINIC(11A,B)  9CJ1460
C             AND MONOCLINIC(10A,B)                                      9CJ1470
C                                                                        9CJ1480
  180 IF (ISYM.NE.3) GO TO 183                                           9CJ1490
      IF (ABS(BC+AA/2.) - DEL) 181,181,98                                9CJ1500
  181 IF (ABS(AB-AA/2.) - DEL) 14,14,182                                 9CJ1510
  182 IF (ABS(AB+AA/2.) - DEL) 15,15,98                                  9CJ1520
  183 IF (ISYM.NE.4) GO TO 98                                            9CJ1530
      IF (ABS(BC+CC/2.) - DEL) 184,184,187                               9CJ1540
  184 IF (ABS(AB-AA/2.) - DEL) 22,22,185                                 9CJ1550
  185 IF (ABS(AB+AA/2.) - DEL) 23,23,186                                 9CJ1560
  186 IF (AB) 25,160,24                                                  9CJ1570
  187 IF (ABS(AB-AA/2.) - DEL) 26,26,188                                 9CJ1580
  188 IF (ABS(AB+AA/2.) - DEL) 27,27,98                                  9CJ1590
C                                                                        9CJ1600
C          2. TEST FOR CUBIC(42), TETRAGONAL(34A,B,C) AND                9CJ1610
C             ORTHORHOMBIC(25A,B,C).                                     9CJ1620
C                                                                        9CJ1630
  200 IF (ISYM.NE.1) GO TO 230                                           9CJ1640
      IF (ABS(BC+CA+AB + AA) - DEL) 201,201,230                          9CJ1650
  201 IF (ABS(ABS(BC) - AA/3.) - DEL) 202,202,210                        9CJ1660
  202 IF (ABS(ABS(CA) - AA/3.) - DEL) 203,203,210                        9CJ1670
  203 IF (ABS(ABS(AB) - AA/3.) - DEL) 16,16,210                          9CJ1680
C                                                                        9CJ1690
  210 IF (ABS(ABS(CA) - ABS(AB)) - DEL) 211,211,212                      9CJ1700
  211 IF (ABS(ABS(CA) - ABS((-AA-BC)/2.)) - DEL) 17,17,230               9CJ1710
  212 IF (ABS(ABS(BC) - ABS(AB)) - DEL) 213,213,214                      9CJ1720
  213 IF (ABS(ABS(BC) - ABS(-AA-CA)/2.) - DEL) 18,18,230                 9CJ1730
  214 IF (ABS(ABS(BC) - ABS(CA)) - DEL) 215,215,220                      9CJ1740
  215 IF (ABS(ABS(BC) - ABS((-AA-AB)/2.)) - DEL) 19,19,230               9CJ1750
C                                                                        9CJ1760
  220 IF (ABS(ABS(BC) - ABS(-AA-CA-AB)) - DEL) 20,20,221                 9CJ1770
  221 IF (ABS(ABS(CA) - ABS(-AA-BC-AB)) - DEL) 21,21,222                 9CJ1780
  222 IF (ABS(ABS(AB) - ABS(-AA-BC-CA)) - DEL) 22,22,230                 9CJ1790
C                                                                        9CJ1800
C          3. TEST FOR R(2,3) = R(3,1)                                   9CJ1810
C                                                                        9CJ1820
  230 IF (ABS(ABS(BC) - ABS(CA)) - DEL) 231,231,270                      9CJ1830
  231 IF (ABS(BC+AA/2.) - DEL) 241,241,232                               9CJ1840
  232 IF (ABS(BC+CC/2.) - DEL) 250,250,233                               9CJ1850
  233 IF (ABS(BC+CC/3.) - DEL) 256,256,260                               9CJ1860
C                                                                        9CJ1870
C             R(2,3) = R(3,1) = -R(1,1)/2.                               9CJ1880
C             CUBIC(43A,B) AND RHOMBOHEDRAL(35)                          9CJ1890
C                                                                        9CJ1900
  240 GO TO (12,98,98,98), ISYM                                          9CJ1910
  241 IF (ABS(AB-AA/2.) - DEL) 242,242,260                               9CJ1920
  242 GO TO (13,98,18,98), ISYM                                          9CJ1930
C                                                                        9CJ1940
C             R(2,3) = R(3,1) = -R(3,3)/2.                               9CJ1950
C             TETRAGONAL(33), ORTHORHOMBIC(29), ORTHORHOMBIC(26A,B)      9CJ1960
C             AND MONOCLINIC(8)                                          9CJ1970
C                                                                        9CJ1980
  250 IF (ABS(AB-CC/4.) - DEL) 251,251,252                               9CJ1990
  251 GO TO (98,16,98,28), ISYM                                          9CJ2000
  252 IF (AB) 253,254,254                                                9CJ2010
  253 IF (ISYM.EQ.2) GO TO 18                                            9CJ2020
      GO TO 260                                                          9CJ2030
  254 GO TO (98,17,98,29), ISYM                                          9CJ2040
C                                                                        9CJ2050
C             R(2,3) = R(3,1) = -R(3,3)/3.                               9CJ2060
C             RHOMBOHEDRAL(38)                                           9CJ2070
C                                                                        9CJ2080
  256 IF (ISYM.NE.2) GO TO 260                                           9CJ2090
      IF (ABS(ABS(AB) - ABS((-AA+CC/3.)/2.)) - DEL) 19,19,260            9CJ2100
C                                                                        9CJ2110
C             R(2,3) = R(3,1) NOT NECESSARILY = R(1,2)                   9CJ2120
C             RHOMBOHEDRAL(36), RHOMBOHEDRAL(37), MONOCLINIC(14)         9CJ2130
C             AND MONOCLINIC(15)                                         9CJ2140
C                                                                        9CJ2150
  260 IF (ABS(ABS(BC) - ABS(AB)) - DEL) 261,261,262                      9CJ2160
  261 IF (ISYM.NE.1) GO TO 262                                           9CJ2170
      IF (AB) 15,98,14                                                   9CJ2180
  262 IF (ISYM.NE.2) GO TO 270                                           9CJ2190
      IF (AB) 21,98,20                                                   9CJ2200
C                                                                        9CJ2210
C          4. TEST FOR ABS(R(2,3)) = ABS(R(1,2)).                        9CJ2220
C             ORTHORHOMBIC(28), MONOCLINIC(12) AND MONOCLINIC(13)        9CJ2230
C                                                                        9CJ2240
  270 IF (ABS(ABS(BC) - ABS(AB)) - DEL) 271,271,280                      9CJ2250
  271 IF (ISYM.NE.3) GO TO 280                                           9CJ2260
      IF (ABS(CA - (-AA - 2.*BC)) - DEL) 19,19,272                       9CJ2270
  272 IF (AB) 17,98,16                                                   9CJ2280
C                                                                        9CJ2290
C          5. TEST FOR REMAINING CELLS.                                  9CJ2300
C                                                                        9CJ2310
C             MONOCLINIC(7)                                              9CJ2320
C                                                                        9CJ2330
  280 IF (ISYM.NE.3) GO TO 300                                           9CJ2340
  290 IF (ABS(ABS(CA) - ABS(-AA-BC-AB)) - DEL) 20,20,300                 9CJ2350
C                                                                        9CJ2360
C             MONOCLINIC(16)                                             9CJ2370
C                                                                        9CJ2380
  300 GO TO (340,98,98,301), ISYM                                        9CJ2390
  301 IF (ABS(BC + CC/2.) - DEL) 302,302,310                             9CJ2400
  302 IF (ABS(AB + CA/2.) - DEL) 30,30,310                               9CJ2410
C                                                                        9CJ2420
C             MONOCLINIC(17)                                             9CJ2430
C                                                                        9CJ2440
  310 IF (ABS(BC - CA/2.) - DEL) 311,311,320                             9CJ2450
  311 IF (ABS(AB - AA/2.) - DEL) 31,31,320                               9CJ2460
C                                                                        9CJ2470
C             MONOCLINIC(18)                                             9CJ2480
C                                                                        9CJ2490
  320 IF (ABS(AB + BC/2.) - DEL) 321,321,330                             9CJ2500
  321 IF (ABS(CA + CC/2.) - DEL) 32,32,330                               9CJ2510
C                                                                        9CJ2520
C             MONOCLINIC(6)                                              9CJ2530
C                                                                        9CJ2540
  330 IF (ABS(ABS(BC) - ABS((-CC - CA)/2.)) - DEL) 331,331,340           9CJ2550
  331 IF (ABS(ABS(AB) - ABS((-AA - CA)/2.)) - DEL) 33,33,340             9CJ2560
C                                                                        9CJ2570
C             TRICLINIC(1) AND TRICLINIC(2)                              9CJ2580
C                                                                        9CJ2590
  340 ISYM = 4                                                           9CJ2600
      IF (AB) 35,34,34                                                   9CJ2610
C                                                                        9CJ2620
   11 JU = 1                                                             9CJ2630
      GO TO 65                                                           9CJ2640
   12 JU = 2                                                             9CJ2650
      GO TO 65                                                           9CJ2660
   13 JU = 3                                                             9CJ2670
      GO TO 65                                                           9CJ2680
   14 JU = 4                                                             9CJ2690
      GO TO 65                                                           9CJ2700
   15 JU = 5                                                             9CJ2710
      GO TO 65                                                           9CJ2720
   16 JU = 6                                                             9CJ2730
      GO TO 65                                                           9CJ2740
   17 JU = 7                                                             9CJ2750
      GO TO 65                                                           9CJ2760
   18 JU = 8                                                             9CJ2770
      GO TO 65                                                           9CJ2780
   19 JU = 9                                                             9CJ2790
      GO TO 65                                                           9CJ2800
   20 JU = 10                                                            9CJ2810
      GO TO 65                                                           9CJ2820
   21 JU = 11                                                            9CJ2830
      GO TO 65                                                           9CJ2840
   22 JU = 12                                                            9CJ2850
      GO TO 65                                                           9CJ2860
   23 JU = 13                                                            9CJ2870
      GO TO 65                                                           9CJ2880
   24 JU = 14                                                            9CJ2890
      GO TO 65                                                           9CJ2900
   25 JU = 15                                                            9CJ2910
      GO TO 65                                                           9CJ2920
   26 JU = 16                                                            9CJ2930
      GO TO 65                                                           9CJ2940
   27 JU = 17                                                            9CJ2950
      GO TO 65                                                           9CJ2960
   28 JU = 18                                                            9CJ2970
      GO TO 65                                                           9CJ2980
   29 JU = 19                                                            9CJ2990
      GO TO 65                                                           9CJ3000
   30 JU = 20                                                            9CJ3010
      GO TO 65                                                           9CJ3020
   31 JU = 21                                                            9CJ3030
      GO TO 65                                                           9CJ3040
   32 JU = 22                                                            9CJ3050
      GO TO 65                                                           9CJ3060
   33 JU = 23                                                            9CJ3070
      GO TO 65                                                           9CJ3080
   34 JU = 24                                                            9CJ3090
      GO TO 65                                                           9CJ3100
   35 JU = 25                                                            9CJ3110
C                                                                        9CJ3120
C          TESTS COMPLETED.  NOW EXECUTE ASSIGNMENT OF MATRIX ELEMENTS   9CJ3130
C     FOR TRANSFORMATION OF REDUCED CELL (IN CONVENTIONAL FORM) TO       9CJ3140
C     UNIT CELL.                                                         9CJ3150
C                                                                        9CJ3160
C                                                                        9CJ3170
   65 DO 7 I = 1,9                                                       9CJ3180
      GO TO (66,67,68,69), ISYM                                          9CJ3190
   66 GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009), I            9CJ3200
   67 GO TO (1011,1012,1013,1014,1015,1016,1017,1018,1019), I            9CJ3210
   68 GO TO (1021,1022,1023,1024,1025,1026,1027,1028,1029), I            9CJ3220
   69 GO TO (1031,1032,1033,1034,1035,1036,1037,1038,1039), I            9CJ3230
C                                                                        9CJ3240
C          ISYM = 1                                                      9CJ3250
C                                                                        9CJ3260
CELL ORDER = 41,43A,43B,36,37,42,34A,34B,34C,25A,25B,25C,HEX(SPEC.CASE)  9CJ3270
 1001 GO TO (1,1,1,4,1,1,1,1,4,1,4,1,4), JU                              9CJ3280
 1002 GO TO (4,5,1,1,4,1,4,1,1,1,1,4,1), JU                              9CJ3290
 1003 GO TO (4,4,1,4,4,4,1,4,1,4,1,1,4), JU                              9CJ3300
 1004 GO TO (4,1,1,1,4,4,1,4,1,4,1,1,4), JU                              9CJ3310
 1005 GO TO (1,1,5,4,1,1,1,1,4,1,4,1,4), JU                              9CJ3320
 1006 GO TO (4,4,5,4,4,1,4,1,1,1,1,4,1), JU                              9CJ3330
 1007 GO TO (4,1,5,4,4,1,4,1,1,1,1,4,1), JU                              9CJ3340
 1008 GO TO (4,1,1,4,4,4,1,4,1,4,1,1,4), JU                              9CJ3350
 1009 GO TO (1,2,5,5,1,1,1,1,4,1,4,1,4), JU                              9CJ3360
C                                                                        9CJ3370
C          ISYM = 2                                                      9CJ3380
C                                                                        9CJ3390
CELL ORDER = 31,40A,40B,24A,24B,33,26A,26B,38,14,15                      9CJ3400
 1011 GO TO (1,1,1,5,1,1,1,1,1,1,1), JU                                  9CJ3410
 1012 GO TO (4,4,4,1,1,5,1,5,1,1,1), JU                                  9CJ3420
 1013 GO TO (4,4,4,4,4,4,1,4,1,4,4), JU                                  9CJ3430
 1014 GO TO (4,5,4,1,5,1,5,1,5,5,5), JU                                 P9CJ3440
 1015 GO TO (1,1,1,1,1,1,1,1,4,1,1), JU                                  9CJ3450
 1016 GO TO (4,4,4,4,4,1,4,1,4,4,4), JU                                  9CJ3460
 1017 GO TO (4,4,4,4,4,4,4,4,4,4,4), JU                                  9CJ3470
 1018 GO TO (4,4,4,4,4,4,4,4,5,4,4), JU                                 P9CJ3480
 1019 GO TO (1,1,1,1,1,1,1,1,4,1,1), JU                                  9CJ3490
C                                                                        9CJ3500
C          ISYM = 3                                                      9CJ3510
C                                                                        9CJ3520
CELL ORDER = 30,39,23,32A,32B,12,13,35,28,7                              9CJ3530
 1021 GO TO (4,4,1,5,4,5,1,4,5,1), JU                                    9CJ3540
 1022 GO TO (4,4,4,4,4,4,4,1,4,4), JU                                    9CJ3550
 1023 GO TO (1,1,1,4,1,1,1,1,1,5), JU                                    9CJ3560
 1024 GO TO (1,1,1,4,1,1,1,4,4,1), JU                                    9CJ3570
 1025 GO TO (4,4,4,4,4,4,4,1,2,4), JU                                    9CJ3580
 1026 GO TO (4,4,5,1,4,1,5,4,1,1), JU                                    9CJ3590
 1027 GO TO (4,4,4,5,1,4,4,5,5,5), JU                                    9CJ3600
 1028 GO TO (1,1,1,2,2,1,1,1,4,5), JU                                    9CJ3610
 1029 GO TO (4,4,4,1,1,4,4,4,5,4), JU                                    9CJ3620
C                                                                        9CJ3630
C          ISYM = 4                                                      9CJ3640
C                                                                        9CJ3650
CELL ORDER = 19,22A,22B,4A,4B,20,5,9A,9B,21,3,27A,27B,11A,11B,10A,10B,   9CJ3660
C            29,8,16,17,18,6,1,2                                         9CJ3670
 1031 GO TO (1,1,1,5,1,4,4,2,2,4,4,5,1,4,4,5,1,2,6,4,1,4,1,1,1), JU      9CJ3680
 1032 GO TO (4,4,4,4,4,4,4,4,4,4,4,4,4,2,2,2,2,4,4,4,4,4,4,4,4), JU      9CJ3690
 1033 GO TO (4,4,4,4,4,1,1,1,1,1,1,4,4,1,1,4,4,1,5,1,4,1,1,4,4), JU      9CJ3700
 1034 GO TO (4,5,5,4,4,6,4,4,4,4,1,5,1,4,4,5,1,4,4,4,5,2,1,4,4), JU      9CJ3710
 1035 GO TO (1,2,6,4,4,4,1,4,4,6,4,2,2,4,4,4,4,2,4,2,2,4,2,1,1), JU      9CJ3720
 1036 GO TO (4,4,4,1,5,5,4,1,1,5,4,1,1,1,1,4,4,1,1,1,4,1,1,4,4), JU      9CJ3730
 1037 GO TO (4,4,4,4,4,4,1,4,4,1,4,4,4,5,1,4,4,4,1,1,4,4,4,4,4), JU      9CJ3740
 1038 GO TO (4,4,4,1,1,1,4,5,1,4,1,4,4,4,4,4,4,4,5,4,4,1,4,4,4), JU      9CJ3750
 1039 GO TO (1,1,1,4,4,4,4,4,4,4,4,1,1,4,4,1,1,1,4,4,1,4,5,1,1), JU      9CJ3760
C                                                                        9CJ3770
    1 EU(I) = 1                                                          9CJ3780
      GO TO 7                                                            9CJ3790
    2 EU(I) = 2                                                          9CJ3800
      GO TO 7                                                            9CJ3810
C   3 EU(I) = 3                                                         P9CJ3820
C     GO TO 7                                                           P9CJ3830
    4 EU(I) = 0                                                          9CJ3840
      GO TO 7                                                            9CJ3850
    5 EU(I) = -1                                                         9CJ3860
      GO TO 7                                                            9CJ3870
    6 EU(I) = -2                                                         9CJ3880
    7 CONTINUE                                                           9CJ3890
C                                                                        9CJ3900
C          GENERATE INVERSE TRANSFORMATION MATRIX OF EU                  9CJ3910
C                                                                        9CJ3920
   50 DETEU = EU(1)*(EU(5)*EU(9)-EU(8)*EU(6)) - EU(2)*(EU(4)*EU(9)-      9CJ3930
     1 EU(7)*EU(6)) + EU(3)*(EU(4)*EU(8)-EU(7)*EU(5))                    9CJ3940
C                                                                        9CJ3950
      IF (DETEU) 51,96,54                                                9CJ3960
   51 DETEU = -DETEU                                                     9CJ3970
      DO 53 I = 1,9                                                      9CJ3980
      IF (EU(I)) 52,53,52                                                9CJ3990
   52 EU(I) = -EU(I)                                                     9CJ4000
   53 CONTINUE                                                           9CJ4010
C                                                                        9CJ4020
   54 EUI(1) =  (EU(5)*EU(9) - EU(8)*EU(6)) / DETEU                      9CJ4030
      EUI(2) = -(EU(2)*EU(9) - EU(8)*EU(3)) / DETEU                      9CJ4040
      EUI(3) =  (EU(2)*EU(6) - EU(5)*EU(3)) / DETEU                      9CJ4050
      EUI(4) = -(EU(4)*EU(9) - EU(7)*EU(6)) / DETEU                      9CJ4060
      EUI(5) =  (EU(1)*EU(9) - EU(7)*EU(3)) / DETEU                      9CJ4070
      EUI(6) = -(EU(1)*EU(6) - EU(4)*EU(3)) / DETEU                      9CJ4080
      EUI(7) =  (EU(5)*EU(8) - EU(7)*EU(5)) / DETEU                      9CJ4090
      EUI(8) = -(EU(1)*EU(8) - EU(7)*EU(2)) / DETEU                      9CJ4100
      EUI(9) =  (EU(1)*EU(5) - EU(4)*EU(2)) / DETEU                      9CJ4110
      DETEUI = 1./DETEU                                                  9CJ4120
C                                                                        9CJ4130
      DO 362 I = 1,9                                                     9CJ4140
      IF (EUI(I)) 362,361,362                                            9CJ4150
  361 EUI(I) = 0.0                                                       9CJ4160
  362 CONTINUE                                                           9CJ4170
C                                                                        9CJ4180
C          CALCULATE THE NEW CELL PARAMETERS                             9CJ4190
C                                                                        9CJ4200
      ABC = A*B*COSGA                                                    9CJ4210
      ACC = A*C*COSBE                                                    9CJ4220
      BCC = B*C*COSAL                                                    9CJ4230
      A2 = SQRT((EU(1)*A)**2 + (EU(2)*B)**2 + (EU(3)*C)**2               9CJ4240
     1 + 2.*(EU(2)*EU(3)*BCC + EU(1)*EU(3)*ACC + EU(1)*EU(2)*ABC))       9CJ4250
      B2 = SQRT((EU(4)*A)**2 + (EU(5)*B)**2 + (EU(6)*C)**2               9CJ4260
     1 + 2.*(EU(5)*EU(6)*BCC + EU(4)*EU(6)*ACC + EU(4)*EU(5)*ABC))       9CJ4270
      C2 = SQRT((EU(7)*A)**2 + (EU(8)*B)**2 + (EU(9)*C)**2               9CJ4280
     1 + 2.*(EU(8)*EU(9)*BCC + EU(7)*EU(9)*ACC + EU(7)*EU(8)*ABC))       9CJ4290
      ALPHA2 = 57.295780 *  ACOS((EU(4)*EU(7)*A*A + EU(5)*EU(8)*B*B      9CJ4300
     1 + EU(6)*EU(9)*C*C + (EU(4)*EU(8)+EU(5)*EU(7))*ABC + (EU(4)*EU(9)  9CJ4310
     2 +EU(6)*EU(7))*ACC + (EU(5)*EU(9)+EU(6)*EU(8))*BCC) / (B2*C2))     9CJ4320
      BETA2  = 57.295780 *  ACOS((EU(1)*EU(7)*A*A + EU(2)*EU(8)*B*B      9CJ4330
     1 + EU(3)*EU(9)*C*C + (EU(1)*EU(8)+EU(2)*EU(7))*ABC + (EU(1)*EU(9)  9CJ4340
     2 +EU(3)*EU(7))*ACC + (EU(2)*EU(9)+EU(3)*EU(8))*BCC) / (A2*C2))     9CJ4350
      GAMMA2 = 57.295780 *  ACOS((EU(1)*EU(4)*A*A + EU(2)*EU(5)*B*B      9CJ4360
     1 + EU(3)*EU(6)*C*C + (EU(1)*EU(5)+EU(2)*EU(4))*ABC + (EU(1)*EU(6)  9CJ4370
     2 +EU(3)*EU(4))*ACC + (EU(2)*EU(6)+EU(3)*EU(5))*BCC) / (A2*B2))     9CJ4380
C                                                                        9CJ4390
C          OUTPUT RESULTS                                                9CJ4400
C                                                                        9CJ4410
      JSUM = ISUM + 1                                                    9CJ4420
      GO TO (401,402,403,404),ISYM                                       9CJ4430
  401 GO TO (712,714,714,710,710,713,709,709,709,706,706,706,711), JU    9CJ4440
  402 GO TO (708,711,711,705,705,709,706,706,710,703,703), JU            9CJ4450
  403 GO TO (708,711,705,709,709,703,703,710,707,703), JU                9CJ4460
  404 GO TO (704,705,705,702,702,705,702,703,703,705,702,706,706,703,    9CJ4470
     1   703,703,703,707,703,703,703,703,703,701,701), JU                9CJ4480
  701 PRINT 5001, JSUM                                                   9CJ4490
      GO TO 89                                                           9CJ4500
  702 PRINT 5002, JSUM                                                   9CJ4510
      GO TO 89                                                           9CJ4520
  703 PRINT 5003, JSUM                                                   9CJ4530
      GO TO 89                                                           9CJ4540
  704 PRINT 5004, JSUM                                                   9CJ4550
      GO TO 89                                                           9CJ4560
  705 PRINT 5005, JSUM                                                   9CJ4570
      GO TO 89                                                           9CJ4580
  706 PRINT 5006, JSUM                                                   9CJ4590
      GO TO 89                                                           9CJ4600
  707 PRINT 5007, JSUM                                                   9CJ4610
      GO TO 89                                                           9CJ4620
  708 PRINT 5008, JSUM                                                   9CJ4630
      GO TO 89                                                           9CJ4640
  709 PRINT 5009, JSUM                                                   9CJ4650
      GO TO 89                                                           9CJ4660
  710 PRINT 5010, JSUM                                                   9CJ4670
      GO TO 89                                                           9CJ4680
  711 PRINT 5011, JSUM                                                   9CJ4690
      GO TO 89                                                           9CJ4700
  712 PRINT 5012, JSUM                                                   9CJ4710
      GO TO 89                                                           9CJ4720
  713 PRINT 5013, JSUM                                                   9CJ4730
      GO TO 89                                                           9CJ4740
  714 PRINT 5014, JSUM                                                   9CJ4750
      GO TO 89                                                           9CJ4760
 5001 FORMAT (1H ,9X,7H CELL (,I1,1H),24H   TRICLINIC (PRIMITIVE))       9CJ4770
 5002 FORMAT (1H ,9X,7H CELL (,I1,1H),25H   MONOCLINIC (PRIMITIVE))      9CJ4780
 5003 FORMAT (1H ,9X,7H CELL (,I1,1H),26H   MONOCLINIC (C-CENTERED))     9CJ4790
 5004 FORMAT (1H ,9X,7H CELL (,I1,1H),27H   ORTHORHOMBIC (PRIMITIVE))    9CJ4800
 5005 FORMAT (1H ,9X,7H CELL (,I1,1H),28H   ORTHORHOMBIC (C-CENTERED))   9CJ4810
 5006 FORMAT (1H ,9X,7H CELL (,I1,1H),31H   ORTHORHOMBIC (BODY-CENTERED) 9CJ4820
     1)                                                                  9CJ4830
 5007 FORMAT (1H ,9X,7H CELL (,I1,1H),31H   ORTHORHOMBIC (FACE-CENTERED) 9CJ4840
     1)                                                                  9CJ4850
 5008 FORMAT (1H ,9X,7H CELL (,I1,1H),25H   TETRAGONAL (PRIMITIVE))      9CJ4860
 5009 FORMAT (1H ,9X,7H CELL (,I1,1H),29H   TETRAGONAL (BODY-CENTERED))  9CJ4870
 5010 FORMAT (1H ,9X,7H CELL (,I1,1H),27H   RHOMBOHEDRAL (PRIMITIVE))    9CJ4880
 5011 FORMAT (1H ,9X,7H CELL (,I1,1H),24H   HEXAGONAL (PRIMITIVE))       9CJ4890
 5012 FORMAT (1H ,9X,7H CELL (,I1,1H),20H   CUBIC (PRIMITIVE))           9CJ4900
 5013 FORMAT (1H ,9X,7H CELL (,I1,1H),24H   CUBIC (BODY-CENTERED))       9CJ4910
 5014 FORMAT (1H ,9X,7H CELL (,I1,1H),24H   CUBIC (FACE-CENTERED))       9CJ4920
C                                                                        9CJ4930
   92 PRINT 6019, ISUM,JSUM,JSUM,ISUM                                    9CJ4940
      PRINT 6020, EU(1),EU(2),EU(3),EUI(1),EUI(2),EUI(3),EU(4),EU(5),    9CJ4950
     1 EU(6),EUI(4),EUI(5),EUI(6),EU(7),EU(8),EU(9),EUI(7),EUI(8),EUI(9) 9CJ4960
      PRINT 6046, DETEU,DETEUI                                           9CJ4970
      LINE = LINE + 1                                                    9CJ4980
      IF (LINE - 5) 89,730,730                                           9CJ4990
  730 LINE = 1                                                           9CJ5000
      PRINT 4998, (TITLE(I), I = 1,35)                                   9CJ5010
      GO TO 89                                                           9CJ5020
C                                                                        9CJ5030
C          CALCULATE MATRIX ELEMENTS, F, FOR TRANSFORMATION OF ORIGINAL  9CJ5040
C     CELL TO FINAL UNIT CELL                                            9CJ5050
C                                                                        9CJ5060
   93 F(1) = EU(1)*P(1,1,L2) + EU(2)*P(2,1,L2) + EU(3)*P(3,1,L2)         9CJ5070
      F(2) = EU(1)*P(1,2,L2) + EU(2)*P(2,2,L2) + EU(3)*P(3,2,L2)         9CJ5080
      F(3) = EU(1)*P(1,3,L2) + EU(2)*P(2,3,L2) + EU(3)*P(3,3,L2)         9CJ5090
      F(4) = EU(4)*P(1,1,L2) + EU(5)*P(2,1,L2) + EU(6)*P(3,1,L2)         9CJ5100
      F(5) = EU(4)*P(1,2,L2) + EU(5)*P(2,2,L2) + EU(6)*P(3,2,L2)         9CJ5110
      F(6) = EU(4)*P(1,3,L2) + EU(5)*P(2,3,L2) + EU(6)*P(3,3,L2)         9CJ5120
      F(7) = EU(7)*P(1,1,L2) + EU(8)*P(2,1,L2) + EU(9)*P(3,1,L2)         9CJ5130
      F(8) = EU(7)*P(1,2,L2) + EU(8)*P(2,2,L2) + EU(9)*P(3,2,L2)         9CJ5140
      F(9) = EU(7)*P(1,3,L2) + EU(8)*P(2,3,L2) + EU(9)*P(3,3,L2)         9CJ5150
C                                                                        9CJ5160
C          GENERATE INVERSE TRANSFORMATION MATRIX OF F                   9CJ5170
C                                                                        9CJ5180
      DETFN = F(1)*(F(5)*F(9)-F(8)*F(6)) - F(2)*(F(4)*F(9)-F(7)*F(6)) +  9CJ5190
     1 F(3)*(F(4)*F(8)-F(7)*F(5))                                        9CJ5200
      IF (DETFN.EQ.0.0) GO TO 97                                         9CJ5210
      FI(1) =  (F(5)*F(9) - F(8)*F(6)) / DETFN                           9CJ5220
      FI(2) = -(F(2)*F(9) - F(8)*F(3)) / DETFN                           9CJ5230
      FI(3) =  (F(2)*F(6) - F(5)*F(3)) / DETFN                           9CJ5240
      FI(4) = -(F(4)*F(9) - F(7)*F(6)) / DETFN                           9CJ5250
      FI(5) =  (F(1)*F(9) - F(7)*F(3)) / DETFN                           9CJ5260
      FI(6) = -(F(1)*F(6) - F(4)*F(3)) / DETFN                           9CJ5270
      FI(7) =  (F(4)*F(8) - F(7)*F(5)) / DETFN                           9CJ5280
      FI(8) = -(F(1)*F(8) - F(7)*F(2)) / DETFN                           9CJ5290
      FI(9) =  (F(1)*F(5) - F(4)*F(2)) / DETFN                           9CJ5300
      DETFNI = 1./DETFN                                                  9CJ5310
C                                                                        9CJ5320
      DO 366 I = 1,9                                                     9CJ5330
      IF (F(I)) 364,363,364                                              9CJ5340
  363 F(I) = 0.0                                                         9CJ5350
  364 IF (FI(I)) 366,365,366                                             9CJ5360
  365 FI(I) = 0.0                                                        9CJ5370
  366 CONTINUE                                                           9CJ5380
C                                                                        9CJ5390
  731 LINE = LINE + 1                                                    9CJ5400
      IF (LINE - 5) 733,732,732                                          9CJ5410
  732 LINE = 1                                                           9CJ5420
      PRINT 4998, (TITLE(I), I = 1,35)                                   9CJ5430
  733 PRINT 6021, JSUM,JSUM                                              9CJ5440
      PRINT 6020, F(1),F(2),F(3),FI(1),FI(2),FI(3),F(4),F(5),F(6),FI(4), 9CJ5450
     1 FI(5),FI(6),F(7),F(8),F(9),FI(7),FI(8),FI(9)                      9CJ5460
      PRINT 6046, DETFN,DETFNI                                           9CJ5470
      GO TO 89                                                           9CJ5480
 6019 FORMAT (1H0/,13X, 7H CELL (,I1,11H) TO CELL (,I1,1H),              9CJ5490
     1             12X, 7H CELL (,I1,11H) TO CELL (,I1,1H) // )          9CJ5500
 6020 FORMAT (1H , 11X, 3F7.2, 12X, 3F7.2 / )                            9CJ5510
 6021 FORMAT (1H0/,13X, 19H CELL (1) TO CELL (,I1,1H),                   9CJ5520
     1             12X,  7H CELL (,I1,13H) TO CELL (1) // )              9CJ5530
 6046 FORMAT (1H ,16X,6H MOD = F8.4,19X,6H MOD = F8.4 / )                9CJ5540
C                                                                        9CJ5550
   94 A = A2                                                             9CJ5560
      B = B2                                                             9CJ5570
      C = C2                                                             9CJ5580
      ALPHA = ALPHA2                                                     9CJ5590
      BETA  = BETA2                                                      9CJ5600
      GAMMA = GAMMA2                                                     9CJ5610
      PRINT 4998, (TITLE(I), I = 1,35)                                   9CJ5620
 4998 FORMAT (1H1,//5X,35A2 / )                                          9CJ5630
      GO TO (411,412,413,414),ISYM                                       9CJ5640
  411 GO TO (812,814,814,810,810,813,809,809,809,806,806,806,811), JU    9CJ5650
  412 GO TO (808,811,811,805,805,809,806,806,810,803,803), JU            9CJ5660
  413 GO TO (808,811,805,809,809,803,803,810,807,803), JU                9CJ5670
  414 GO TO (804,805,805,802,802,805,802,803,803,805,802,806,806,803,    9CJ5680
     1   803,803,803,807,803,803,803,803,803,801,801), JU                9CJ5690
C                                                                        9CJ5700
  801 PRINT 6001, JSUM                                                   9CJ5710
      GO TO 910                                                          9CJ5720
  802 PRINT 6002, JSUM                                                   9CJ5730
      GO TO 901                                                          9CJ5740
  803 PRINT 6003, JSUM                                                   9CJ5750
      GO TO 901                                                          9CJ5760
  804 PRINT 6004, JSUM                                                   9CJ5770
      GO TO 907                                                          9CJ5780
  805 PRINT 6005, JSUM                                                   9CJ5790
      GO TO 907                                                          9CJ5800
  806 PRINT 6006, JSUM                                                   9CJ5810
      GO TO 907                                                          9CJ5820
  807 PRINT 6007, JSUM                                                   9CJ5830
      GO TO 907                                                          9CJ5840
  808 PRINT 6008, JSUM                                                   9CJ5850
      GO TO 902                                                          9CJ5860
  809 PRINT 6009, JSUM                                                   9CJ5870
      GO TO 902                                                          9CJ5880
  810 PRINT 6010, JSUM                                                   9CJ5890
      GO TO 903                                                          9CJ5900
  811 PRINT 6011, JSUM                                                   9CJ5910
      GO TO 904                                                          9CJ5920
  812 PRINT 6012, JSUM                                                   9CJ5930
      GO TO 905                                                          9CJ5940
  813 PRINT 6013, JSUM                                                   9CJ5950
      GO TO 905                                                          9CJ5960
  814 PRINT 6014, JSUM                                                   9CJ5970
      GO TO 905                                                          9CJ5980
 6001 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ5990
     1 26H) -- TRICLINIC (PRIMITIVE))                                    9CJ6000
 6002 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6010
     1 27H) -- MONOCLINIC (PRIMITIVE))                                   9CJ6020
 6003 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6030
     1 28H) -- MONOCLINIC (C-CENTERED))                                  9CJ6040
 6004 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6050
     1 29H) -- ORTHORHOMBIC (PRIMITIVE))                                 9CJ6060
 6005 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6070
     1 30H) -- ORTHORHOMBIC (C-CENTERED))                                9CJ6080
 6006 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6090
     1 33H) -- ORTHORHOMBIC (BODY-CENTERED))                             9CJ6100
 6007 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6110
     1 33H) -- ORTHORHOMBIC (FACE-CENTERED))                             9CJ6120
 6008 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6130
     1 27H) -- TETRAGONAL (PRIMITIVE))                                   9CJ6140
 6009 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6150
     1 31H) -- TETRAGONAL (BODY-CENTERED))                               9CJ6160
 6010 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6170
     1 29H) -- RHOMBOHEDRAL (PRIMITIVE))                                 9CJ6180
 6011 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6190
     1 26H) -- HEXAGONAL (PRIMITIVE))                                    9CJ6200
 6012 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6210
     1 22H) -- CUBIC (PRIMITIVE))                                        9CJ6220
 6013 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6230
     1 26H) -- CUBIC (BODY-CENTERED))                                    9CJ6240
 6014 FORMAT (1H0/10X29H LATTICE PARAMETERS OF CELL (,I1,                9CJ6250
     1 26H) -- CUBIC (FACE-CENTERED))                                    9CJ6260
C                                                                        9CJ6270
C          RESET CELL EDGES AND CELL ANGLES AS PRESCRIBED BY SYMMETRY.   9CJ6280
C     GO TO 901 (MONOCLINIC), 902 (TETRAGONAL), 903 (RHOMBOHEDRAL),      9CJ6290
C     904 (HEXAGONAL), 905 (CUBIC), 907 (ORTHORHOMBIC).                  9CJ6300
C                                                                        9CJ6310
  901 ALPHA = 90.0                                                       9CJ6320
      GO TO 909                                                          9CJ6330
  902 A = (A + B) / 2.                                                   9CJ6340
      GO TO 906                                                          9CJ6350
  903 A = (A + B + C) / 3.                                               9CJ6360
      B = A                                                              9CJ6370
      C = A                                                              9CJ6380
      ALPHA = (ALPHA + BETA + GAMMA) / 3.                                9CJ6390
      GO TO 908                                                          9CJ6400
  904 A = (A + B) / 2.                                                   9CJ6410
      B = A                                                              9CJ6420
      ALPHA = 90.0                                                       9CJ6430
      BETA = 90.0                                                        9CJ6440
      GAMMA = 120.0                                                      9CJ6450
      GO TO 910                                                          9CJ6460
  905 A = (A + B + C) / 3.                                               9CJ6470
      C = A                                                              9CJ6480
  906 B = A                                                              9CJ6490
  907 ALPHA = 90.0                                                       9CJ6500
  908 BETA  = ALPHA                                                      9CJ6510
  909 GAMMA = ALPHA                                                      9CJ6520
C                                                                        9CJ6530
  910 PRINT 6030, DEL                                                    9CJ6540
 6030 FORMAT (1H ,9X,73H THIS CELL IS THE SUGGESTED UNIT CELL OF HIGHEST 9CJ6550
     1 SYMMETRY BASED ON DEL = F4.2)                                     9CJ6560
      PRINT 6031, ISYM,JU                                                9CJ6570
 6031 FORMAT (1H ,9X,7H ISYM = I2,4X,5H JU = I3)                         9CJ6580
      IF (ABS(AA - BB) - DEL) 921,921,922                                9CJ6590
  921 IF (ABS((AA + BB)/2. - CC) - DEL) 923,923,924                      9CJ6600
  923 IF (JU.EQ.13) GO TO 931                                            9CJ6610
      IF (ISYM.NE.1) GO TO 931                                           9CJ6620
      GO TO 89                                                           9CJ6630
  924 IF (ISYM.NE.2) GO TO 932                                           9CJ6640
      GO TO 89                                                           9CJ6650
  922 IF (ABS(AA - CC) - DEL) 925,925,89                                 9CJ6660
  925 IF (ISYM.NE.3) GO TO 933                                           9CJ6670
      GO TO 89                                                           9CJ6680
C                                                                        9CJ6690
C          SPECIAL PROGRAM MESSAGES                                      9CJ6700
C                                                                        9CJ6710
  931 PRINT 6040, ISUM                                                   9CJ6720
 6040 FORMAT (1H0,9X,35H WARNING.  THE REDUCED CELL, CELL (,I1,67H), OF  9CJ6730
     1THIS UNIT CELL IS A SPECIAL CASE HAVING PARAMETERS A = B = C.)     9CJ6740
      GO TO 89                                                           9CJ6750
  932 PRINT 6041, ISUM                                                   9CJ6760
 6041 FORMAT (1H0,9X,35H WARNING.  THE REDUCED CELL, CELL (,I1,63H), OF  9CJ6770
     1THIS UNIT CELL IS A SPECIAL CASE HAVING PARAMETERS A = B.)         9CJ6780
      GO TO 89                                                           9CJ6790
  933 PRINT 6042, ISUM                                                   9CJ6800
 6042 FORMAT (1H0,9X,35H WARNING.  THE REDUCED CELL, CELL (,I1,63H), OF  9CJ6810
     1THIS UNIT CELL IS A SPECIAL CASE HAVING PARAMETERS A = C.)         9CJ6820
      GO TO 89                                                           9CJ6830
C                                                                        9CJ6840
   95 PRINT 7001                                                         9CJ6850
 7001 FORMAT (1H0,20X,87H SUBROUTINE TEST HAS FOUND R(2,2) = R(3,3).NE.R 9CJ6860
     1(1,1).  THIS RELATIONSHIP IS NOT ALLOWED / 21X,87H UPON ENTRY INTO 9CJ6870
     2 THIS SUBROUTINE AND INDICATES THE PRESENCE OF AN ERROR IN THE PRO 9CJ6880
     3GRAM. / 21X,42H ISYM HAS BEEN SET TO 4 BEFORE CONTINUING. / )      9CJ6890
      GO TO 727                                                          9CJ6900
C                                                                        9CJ6910
   98 GO TO (725,727,727,503), ISYM                                      9CJ6920
  503 PRINT 7004                                                         9CJ6930
 7004 FORMAT (1H0,20X,70H THIS REDUCED CELL CONTAINS ONE OR MORE INTERRE 9CJ6940
     1LATED OR SPECIAL SCALAR / 21X,74H PRODUCTS INCONSISTENT WITH THE U 9CJ6950
     2NIQUE REDUCED CELLS OF THE TYPE ISYM = 4. / 21X,56H IT WILL THEREF 9CJ6960
     3ORE BE ARBITRARILY ASSIGNED AS TRICLINIC. / )                      9CJ6970
      GO TO 340                                                          9CJ6980
C                                                                        9CJ6990
   96 JSUM = ISUM + 1                                                    9CJ7000
      PRINT 7002, ISUM,JSUM                                              9CJ7010
 7002 FORMAT (1H0,9X,86H A VALUE OF MOD = 0.00 HAS BEEN CALCULATED IN SU 9CJ7020
     1BROUTINE TEST FOR THE MATRIX OF CELL (,I1,11H) TO CELL (,I1,1H)/)  9CJ7030
      GO TO 89                                                           9CJ7040
   97 I = 1                                                              9CJ7050
      PRINT 7002, I,JSUM                                                 9CJ7060
      GO TO 731                                                          9CJ7070
C                                                                        9CJ7080
   89 RETURN                                                             9CJ7090
      END                                                                9CJ7100
                                                                                
                                                                                
                                                                                
